fix use of `eend` in `cleanup` function
[grml-debootstrap.git] / grml-debootstrap
1 #!/bin/bash
2 # Filename:      grml-debootstrap
3 # Purpose:       wrapper around debootstrap for installing plain Debian via Grml
4 # Authors:       grml-team (grml.org), (c) Michael Prokop <mika@grml.org>
5 # Bug-Reports:   see https://grml.org/bugs/
6 # License:       This file is licensed under the GPL v2+
7 ################################################################################
8 # shellcheck disable=SC2001,SC2181
9
10 # error_handler {{{
11 error_handler() {
12    last_exit_code="$?"
13    last_bash_command="$BASH_COMMAND"
14    echo "Unexpected non-zero exit code $last_exit_code in ${BASH_SOURCE[*]} at line ${BASH_LINENO[*]} detected!
15 last bash command: $last_bash_command"
16    ## Check if "bailout" function is available.
17    ## This is not the case in chroot-script.
18    if command -v bailout >/dev/null 2>&1; then
19       bailout 1
20    else
21       exit 1
22    fi
23 }
24
25 set -e
26 set -E
27 set -o pipefail
28 trap "error_handler" ERR
29 export -f "error_handler"
30 # }}}
31
32 # variables {{{
33 PN="$(basename "$0")"
34 if [[ -d "$(dirname "$(command -v "$0")")"/.git ]]; then
35   VERSION="$(git --git-dir "$(dirname "$(command -v "$0")")"/.git describe | sed 's|^v||')"
36 else
37   VERSION="$(dpkg-query --show --showformat='${Version}' "$PN")"
38 fi
39 VERSION="${VERSION:-unknown}"
40 MNTPOINT="/mnt/debootstrap.$$"
41
42 # defaults
43 [ -n "$CHROOT_SCRIPTS" ] || CHROOT_SCRIPTS='yes'
44 [ -n "$CONFFILES" ] || CONFFILES='/etc/debootstrap'
45 [ -n "$DEBCONF" ] || DEBCONF='yes'
46 [ -n "$DEBIAN_FRONTEND" ] || DEBIAN_FRONTEND='noninteractive'
47 [ -n "$DEBOOTSTRAP" ] || DEBOOTSTRAP='debootstrap'
48 [ -n "$DEFAULT_LANGUAGE" ] || DEFAULT_LANGUAGE='en_US:en'
49 [ -n "$DEFAULT_LOCALES" ] || DEFAULT_LOCALES='en_US.UTF-8'
50 [ -n "$DISK_IDENTIFIER" ] || DISK_IDENTIFIER='26ada0c0-1165-4098-884d-aafd2220c2c6'
51 [ -n "$EXTRAPACKAGES" ] || EXTRAPACKAGES='yes'
52 [ -n "$FALLBACK_MIRROR" ] || FALLBACK_MIRROR='http://deb.debian.org/debian'
53 [ -n "$FIXED_DISK_IDENTIFIERS" ] || FIXED_DISK_IDENTIFIERS="no"
54 [ -n "$FORCE" ] || FORCE=''
55 [ -n "$HOSTNAME" ] || HOSTNAME='grml'
56 [ -n "$INITRD" ] || INITRD='yes'
57 [ -n "$INITRD_GENERATOR" ] || INITRD_GENERATOR='initramfs-tools'
58 [ -n "$INITRD_GENERATOR_OPTS" ] || INITRD_GENERATOR_OPTS=''
59 [ -n "$INSTALL_NOTES" ] || INSTALL_NOTES='/etc/debootstrap/install_notes'
60 [ -n "$LOCALES" ] || LOCALES='yes'
61 [ -n "$MIRROR" ] || MIRROR="$FALLBACK_MIRROR"
62 [ -n "$MKFS" ] || MKFS='mkfs.ext4'
63 [ -n "$MKFS_OPTS" ] || MKFS_OPTS=''
64 [ -n "$PACKAGES" ] || PACKAGES='yes'
65 [ -n "$POST_SCRIPTS" ] || POST_SCRIPTS='yes'
66 [ -n "$PRE_SCRIPTS" ] || PRE_SCRIPTS='yes'
67 [ -n "$RECONFIGURE" ] || RECONFIGURE='console-data'
68 [ -n "$RELEASE" ] || RELEASE='bookworm'
69 [ -n "$RM_APTCACHE" ] || RM_APTCACHE='yes'
70 [ -n "$SCRIPTS" ] || SCRIPTS='no' # deprecated, replaced by POST_SCRIPTS
71 [ -n "$SECURE" ] || SECURE='yes'
72 [ -n "$TIMEZONE" ] || TIMEZONE='Europe/Vienna'
73 [ -n "$TUNE2FS" ] || TUNE2FS='tune2fs -c0 -i0'
74 [ -n "$UPGRADE_SYSTEM" ] || UPGRADE_SYSTEM='yes'
75 [ -n "$VMSIZE" ] || VMSIZE="2G"
76 [ -n "$GRUB_INSTALL" ] || GRUB_INSTALL='yes'
77
78 # inside the chroot system locales might not be available, so use minimum:
79 export LANG=C
80 export LC_ALL=C
81 export LANGUAGE=C
82
83 # make sure interactive mode is only executed when
84 # using an empty configuration file or option --interactive
85 INTERACTIVE=''
86 # }}}
87
88 # help text {{{
89 usage() {
90   echo "$PN - wrapper around debootstrap for installing Debian
91
92 Usage: $PN [options]
93
94 Bootstrap options:
95
96   -m, --mirror <URL>     Mirror which should be used for apt-get/aptitude.
97   -i, --iso <mnt>        Mountpoint where a Debian ISO is mounted to, for use
98                          instead of fetching packages from a mirror.
99   -r, --release <name>   Release of new Debian system (default: bullseye).
100   -t, --target <target>  Target partition (/dev/...) or directory where the
101                          system should be installed to.
102   -p, --mntpoint <mnt>   Mountpoint used for mounting the target system,
103                          has no effect if -t is given and represents a directory.
104       --debopt <params>  Extra parameters passed to the debootstrap command.
105       --interactive      Use interactive mode (frontend).
106       --nodebootstrap    Skip debootstrap, only do configuration to the target.
107       --grub <device>    Target for grub installation. Usage example: /dev/sda
108       --efi <device>     Target for EFI installation. Usage example: /dev/sda1
109       --arch <arch>      Set target architecture, use for installing i386 on amd64.
110       --filesystem <fs>  Filesystem that should be used when target is a partition
111                          or Virtual Machine (see --vmfile).
112       --force            Do not prompt for user acknowledgement.
113
114 Options for Virtual Machine deployment:
115
116       --vm               Set up a Virtual Machine on an existing block device
117                          instead of plainly installing to a partition or
118                          directory. Needs to be combined with --target.
119                          Example: --vm --target /dev/mapper/your-vm-disk
120       --vmfile           Like --vm, but install into a regular file (created by
121                          'qemu-img create -f raw ...') instead.
122                          Example: --vmfile --target /mnt/sda1/qemu.img
123       --vmsize <size>    Use specified size for size of VM file (default: 2G).
124                          Syntax as supported by qemu-img, like: --vmsize 3G
125       --vmefi            Create an EFI boot partition for the VM.
126
127 Configuration options:
128
129   -c, --config <file>      Use specified configuration file, defaults to
130                              /etc/debootstrap/config
131   -d, --confdir <path>     Place of config files for debootstrap, defaults
132                              to /etc/debootstrap
133       --packages <file>    Install packages defined in specified list file
134                              instead of using /etc/debootstrap/packages.
135       --nopackages         Skip installation of packages defined in
136                              /etc/debootstrap/packages
137       --nokernel           Skip installation of default kernel images.
138       --nointerfaces       Do not copy /etc/network/interfaces from host system
139                            to target system.
140                            (This option is automatically enabled when using --vmfile.)
141       --defaultinterfaces  Install a default /etc/network/interfaces file (enabling
142                            DHCP for eth0) instead of taking over config from host system.
143       --debconf <file>     Pre-seed packages using specified pre-seed db file.
144       --grmlrepos          Enable Grml's Debian repository (deb.grml.org).
145       --backportrepos      Enable Debian's backports repository (backports.debian.org).
146       --keep_src_list      Do not overwrite user provided apt sources.list.
147       --contrib            Enable 'contrib' in COMPONENTS (defaults to 'main' only).
148       --non-free           Enable non-free / non-free-firmware in COMPONENTS (defaults to 'main' only).
149       --hostname <name>    Hostname of Debian system.
150       --nopassword         Do not prompt for the root password.
151       --password <pwd>     Use specified password as password for user root.
152       --sshcopyauth        Use ${HOME}/.ssh/authorized_keys to authorise root login on the target system.
153       --sshcopyid          Use locally available public keys to authorise root login on the target system.
154       --bootappend <line>  Add specified appendline to kernel whilst booting.
155       --chroot-scripts <d> Execute chroot scripts from specified directory.
156       --pre-scripts <dir>  Execute scripts from specified directory (before chroot-scripts).
157       --scripts <dir>      Execute scripts from specified directory (after chroot-scripts).
158       --remove-configs     Delete grml-debootstrap configuration files from installed system.
159
160 Other options:
161
162   -v, --verbose            Increase verbosity.
163       --debug              Execute in very verbose way.
164   -h, --help               Print this usage information and exit.
165   -V, --version            Show summary of options and exit.
166
167 Usage examples can be found in the grml-debootstrap manpage.
168 Send bugreports to the grml-team: bugs (at) grml.org || https://grml.org/bugs/
169 "
170 }
171
172 if [ "$1" = '-h' ] || [ "$1" = '-help' ] || [ "$1" = "--help" ] ; then
173    usage
174    echo 'Please notice that this script requires root permissions!'
175    exit 0
176 fi
177 # }}}
178
179 # early helper functions {{{
180 # skip colors when running within a dumb terminal
181 if [ "${TERM}" = "dumb" ] ; then
182   GOOD=
183   BAD=
184   WARN=
185   NORMAL=
186 else
187   GOOD='\e[32;01m'
188   BAD='\e[31;01m'
189   WARN='\e[33;01m'
190   NORMAL='\e[0m'
191 fi
192
193 einfo() {
194   einfon "$1\\n"
195   return 0
196 }
197
198 einfon() {
199   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
200   printf " %s*%s $*" "${GOOD}" "${NORMAL}"
201   LAST_E_CMD=einfon
202   return 0
203 }
204
205 ewarn() {
206   printf " %s*%s $*\\n" "${WARN}" "${NORMAL}"
207   return 0
208 }
209
210 eerror() {
211   [ "${RC_ENDCOL}" != "yes" ] && [ "${LAST_E_CMD}" = "ebegin" ] && echo
212   printf " %s*%s $*\\n" "${BAD}" "${NORMAL}" >&2
213   LAST_E_CMD=eerror
214   return 0
215 }
216
217 eend() {
218   local retval="${1:-0}"
219   shift
220   if [ "$retval" -gt 0 ]; then
221     printf " %s-> Failed (rc=%s)%s\\n" "${BAD}" "${retval}" "${NORMAL}"
222   fi
223   return "$retval"
224 }
225
226 check4root(){
227   if [ "$(id -u 2>/dev/null)" != 0 ] ; then
228     echo 1>&2 "Error: please run this script with uid 0 (root)." ; return 1
229   fi
230 }
231
232 check4progs(){
233   local RC=''
234   for arg in "$@" ; do
235     command -v "$arg" >/dev/null 2>&1 || RC="$arg"
236   done
237   if [ -n "$RC" ] ; then
238      echo "$RC not installed"
239      return 1
240   fi
241 }
242 # }}}
243
244 # helper functions {{{
245 cleanup() {
246   if [ -n "$CHROOT_VARIABLES" ] ; then
247     einfo "Removing ${CHROOT_VARIABLES}" ; rm "$CHROOT_VARIABLES" || eend $?
248   fi
249
250   if [ -n "$STAGES" ] ; then
251     einfo "Removing ${STAGES}" ; rmdir "$STAGES" || eend $?
252   fi
253
254   if [ -n "$ARM_EFI_TARGET" ]; then
255     umount "${MNTPOINT}/boot/efi" >/dev/null 2>&1
256   fi
257
258   # Remove temporary mountpoint again
259   if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
260     if [ -d "$MNTPOINT" ] ; then
261       rmdir "$MNTPOINT"
262     fi
263   fi
264
265   # make sure $TARGET is not mounted when exiting grml-debootstrap
266   if [ -n "$MNTPOINT" ] ; then
267     if grep -q "$MNTPOINT" /proc/mounts ; then
268       # make sure nothing is left inside chroot so we can unmount it
269       for service in ssh mdadm ; do
270         if [ -x "${MNTPOINT}/etc/init.d/${service}" ] ; then
271           chroot "$MNTPOINT" "/etc/init.d/${service}" stop
272         fi
273       done
274
275       [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount -a >/dev/null 2>&1
276
277       # ugly, but make sure we really don't leave anything (/proc /proc and
278       # /dev /dev are intended, trying to work around timing issues, see #657023)
279       for ARG in /run/udev /sys /proc /proc /dev/pts /dev/pts /dev /dev ; do
280         [ -x "$MNTPOINT"/bin/umount ] && chroot "$MNTPOINT" umount $ARG >/dev/null 2>&1
281         umount "$MNTPOINT"/$ARG >/dev/null 2>&1
282       done
283
284       if [ -n "$ISODIR" ] ; then
285         [ -d "$MNTPOINT/$ISODIR" ] && umount "$MNTPOINT/$ISODIR" >/dev/null 2>&1
286       fi
287
288       if [ -n "$DIRECTORY" ] ; then
289         einfo "Not unmounting $MNTPOINT as you requested me to install into a directory of your own choice."
290       else
291         einfo "Unmounting $MNTPOINT"
292         umount "$MNTPOINT" || eend $?
293       fi
294
295       if [ -n "$STAGES" ] ; then
296         echo -n "Removing stages directory ${STAGES}: "
297         rm -rf "$STAGES" && echo 'done'
298       fi
299
300       # remove directory only if we used the default with process id inside the name
301       if echo "$MNTPOINT" | grep -q '/mnt/debootstrap\.' ; then
302         if test -d "$MNTPOINT" ; then
303           einfo "Removing directory ${MNTPOINT}"
304           rmdir "$MNTPOINT" || eend $?
305         fi
306       fi
307     fi
308   fi
309
310   if [ -n "${ORIG_TARGET}" ] ; then
311     einfo "Removing loopback mount of file ${ORIG_TARGET}."
312     kpartx -d "${ORIG_TARGET}" || eend $?
313     # Workaround for a bug in kpartx which doesn't clean up properly,
314     # see Debian Bug #891077 and Github-PR grml/grml-debootstrap#112
315     if dmsetup ls | grep -q "^${LOOP_PART} "; then
316       kpartx -d "/dev/${LOOP_DISK}" >/dev/null || eend $?
317     fi
318   fi
319 }
320
321 # we want to exit smoothly and clean:
322 bailout(){
323   eend "$1" || true
324
325   cleanup
326
327   [ -n "$1" ] && EXIT="$1" || EXIT="1"
328   [ -n "$2" ] && einfo "Notice: remove $STAGES/$2 to reexecute the stage"
329
330   exit "$EXIT"
331 }
332 trap bailout HUP INT QUIT TERM
333
334 # we want to execute all the functions only once, simple check for it:
335 stage() {
336   if [ -n "$2" ] ; then
337      echo "$2" > "${STAGES}/${1}"
338      return 0
339   elif grep -q 'done' "${STAGES}/${1}" 2>/dev/null ; then
340      ewarn "Notice: stage $1 has been executed already, skipping execution therefore."
341      ewarn "  To reexecute it clean up the according directory inside $STAGES"
342      return 1
343   fi
344 }
345 # }}}
346
347 # source main configuration file {{{
348 if [ -r /etc/debootstrap/config ] ; then
349   # shellcheck disable=SC1091
350   . /etc/debootstrap/config
351 fi
352 # }}}
353
354 # cmdline handling {{{
355 CMDLINE_OPTS=mirror:,iso:,release:,target:,mntpoint:,debopt:,defaultinterfaces,interactive,nodebootstrap,nointerfaces,nokernel,nopackages,filesystem:,config:,confdir:,packages:,chroot-scripts:,scripts:,post-scripts:,pre-scripts:,debconf:,vm,vmfile,vmsize:,vmefi,keep_src_list,hostname:,password:,nopassword,grmlrepos,backportrepos,bootappend:,grub:,efi:,arch:,insecure,verbose,help,version,force,debug,contrib,non-free,remove-configs,sshcopyid,sshcopyauth
356
357 _opt_temp=$(getopt --name grml-debootstrap -o +m:i:r:t:p:c:d:vhV --long \
358   $CMDLINE_OPTS -- "$@")
359
360 if [ $? != 0 ]; then
361   eerror "Try 'grml-debootstrap --help' for more information."; eend 1; exit 1
362 fi
363 eval set -- "$_opt_temp"
364
365 while :; do
366   case "$1" in
367
368   # == Bootstrap options
369   --mirror|-m)         # Mirror which should be used for apt-get/aptitude
370     shift; _opt_mirror="$1"
371     ;;
372   --iso|-i)            # Mountpoint where a Debian ISO is mounted to
373     shift; _opt_iso="$1"
374     ;;
375   --release|-r)        # Release of new Debian system
376     shift; _opt_release="$1"
377     ;;
378   --target|-t)         # Target partition (/dev/...) or directory
379     shift; _opt_target="$1"
380     ;;
381   --vm)                # Virtual machine image (no file)
382     _opt_vm="T"
383     ;;
384   --vmfile)            # Virtual machine file
385     _opt_vmfile="T"
386     ;;
387   --vmsize)            # size of Virtual machine file
388     shift; _opt_vmsize="$1"
389     ;;
390   --vmefi)            # Create an EFI boot partition for the VM
391     _opt_vmefi="T"
392     ;;
393   --mntpoint|-p)       # Mountpoint used for mounting the target system
394     shift; _opt_mntpoint="$1"
395     ;;
396   --debopt)            # Extra parameters passed to the debootstrap command
397     shift; _opt_debopt="$1"
398     ;;
399   --filesystem)        # Filesystem that should be used
400     shift; _opt_filesystem="$1" ; FILESYSTEM="${_opt_filesystem}"
401     ;;
402   --interactive)       # Use interactive mode (frontend)
403     _opt_interactive=T
404     ;;
405   --nodebootstrap)     # Skip debootstrap, only do configuration to the target
406     _opt_nodebootstrap=T
407     ;;
408   --nopackages)        # Skip installation of packages defined in /etc/debootstrap/packages
409     _opt_nopackages=T
410     ;;
411   --arch)              # Target architecutre
412     shift; _opt_arch="$1"
413     ;;
414   # just for backwards compatibility
415   --insecure)
416     _opt_insecure=T
417     ;;
418   #
419
420   # == Configuration options
421   --config|-c)         # Use specified configuration file, defaults to /etc/debootstrap
422     shift; _opt_config="$1"
423     ;;
424   --confdir|-d)        # Place of config files for debootstrap, defaults to /etc/debootstrap
425     shift; _opt_confdir="$1"
426     ;;
427   --packages)          # Install packages defined in specified file
428     shift; _opt_packages="$1"
429     _opt_packages_set=T
430     ;;
431   --debconf)           # Pre-seed packages using specified file
432     shift; _opt_debconf="$1"
433     _opt_debconf_set=T
434     ;;
435   --pre-scripts)       # Execute scripts from specified directory (before chroot-scripts).
436     shift; _opt_pre_scripts="$1"
437     _opt_pre_scripts_set=T
438     ;;
439   --scripts)           # Execute scripts from specified directory [NOTE: deprecated, replaced via --post-scripts]
440     shift; _opt_scripts="$1"
441     _opt_scripts_set=T
442     ;;
443   --post-scripts)       # Execute scripts from specified directory
444     shift; _opt_post_scripts="$1"
445     _opt_post_scripts_set=T
446     ;;
447   --chroot-scripts)   # Execute chroot scripts from specified directory
448     shift; _opt_chroot_scripts="$1"
449     _opt_chroot_scripts_set=T
450     ;;
451   --keep_src_list)     # Do not overwrite user provided apt sources.list
452     _opt_keep_src_list=T
453     ;;
454   --hostname)          # Hostname of Debian system
455     shift; _opt_hostname="$1"
456     ;;
457   --password)          # Use specified password as password for user root
458     shift; _opt_password="$1"
459     ;;
460   --defaultinterfaces) # Install default /etc/network/interfaces
461     _opt_defaultinterfaces=T
462     ;;
463   --nointerfaces)      # Skip installation of /etc/network/interfaces
464     _opt_nointerfaces=T
465     ;;
466   --nokernel)          # Skip installation of default kernel images
467     _opt_nokernel=T
468     ;;
469   --nopassword)        # Skip password dialog
470     _opt_nopassword=T
471     ;;
472   --sshcopyid)         # Use locally available public keys to authorise root login on the target system
473     _opt_sshcopyid=T
474     ;;
475   --sshcopyauth)       # Use .ssh/authorized_keys to authorise root login on the target system
476     _opt_sshcopyauth=T
477     ;;
478   --grmlrepos)         # Enable Grml repository
479     _opt_grmlrepos=T
480     ;;
481   --backportrepos)     # Enable Debian backports repository
482     _opt_backportrepos=T
483     ;;
484   --bootappend)        # Add specified appendline to kernel whilst booting
485     shift; _opt_bootappend="$1"
486     ;;
487   --grub)              # Target for grub installation. Use grub syntax for specifying
488     shift; _opt_grub="$1"
489     ;;
490   --efi)               # Target for EFI boot installation
491     shift; _opt_efi="$1"
492     ;;
493   --contrib)           # Add 'contrib' to list of components
494     _opt_contrib=T
495     ;;
496   --non-free)          # Add 'non-free' to list of components
497     _opt_non_free=T
498     ;;
499   --remove-configs)    # Drop config files from installed system
500     _opt_remove_configs=T
501     ;;
502
503   # == Other options
504   --verbose|-v)        # Increase verbosity
505     if [ "$_opt_verbose" ]; then
506       _opt_verbose=$( _opt_verbose + 1 )
507     else
508       _opt_verbose=1
509     fi
510     ;;
511   --debug)             # Execute in debug mode
512     _opt_debug=T
513     ;;
514   --help|-h)           # Print usage information and exit
515     _opt_help=T
516     ;;
517   --version|-V)        # Show version information and exit
518     _opt_version=T
519     ;;
520   --force)             # Do not prompt for user input
521     _opt_force=T
522     ;;
523   --)
524     shift; break
525     ;;
526   *)
527     eerror "Internal getopt error!"; eend 1 ; exit 1
528     ;;
529   esac
530   shift
531 done
532
533 # == business-logic of command line parameter-processing
534
535 # source configuration file in <confdir> if supplied. {{{
536 [ "$_opt_confdir" ] && {
537   CONFFILES=$_opt_confdir
538   einfo "Using config files under $CONFFILES/."
539   if ! [ -r "$CONFFILES/config" ] ; then
540     eerror "Error: config file $CONFFILES/config not found."; bailout 1
541   fi
542   # shellcheck disable=SC1091 source=config
543   if ! . "$CONFFILES/config" ; then
544     eerror "Error reading config file $CONFFILES/config" ; bailout 1
545   fi
546   # restore the command line parameter value
547   CONFFILES=$_opt_confdir
548 }
549 # }}}
550
551 [ "$_opt_mirror" ]              && MIRROR=$_opt_mirror
552 [ "$_opt_iso" ]                 && ISO=$_opt_iso
553 [ "$_opt_release" ]             && RELEASE=$_opt_release
554 [ "$_opt_target" ]              && TARGET=$_opt_target
555 [ "$_opt_vm" ]                  && VIRTUAL=1
556 [ "$_opt_vmfile" ]              && VMFILE=1 && VIRTUAL=1
557 [ "$_opt_vmsize" ]              && VMSIZE=$_opt_vmsize
558 [ "$_opt_vmefi" ]               && VMEFI=1
559 [ "$_opt_mntpoint" ]            && MNTPOINT=$_opt_mntpoint
560 [ "$_opt_debopt" ]              && DEBOOTSTRAP_OPT=$_opt_debopt
561 [ "$_opt_interactive" ]         && INTERACTIVE=1
562 [ "$_opt_config" ]              && CONFIGFILE=$_opt_config
563 [ "$_opt_filesystem" ]          && MKFS="mkfs.$_opt_filesystem"
564 [ "$_opt_packages_set" ]        && PACKAGES='yes'
565 [ "$_opt_nopackages" ]          && PACKAGES=''
566 [ "$_opt_debconf_set" ]         && DEBCONF='yes'
567 [ "$_opt_post_scripts_set" ]    && POST_SCRIPTS='yes'
568 [ "$_opt_pre_scripts_set" ]     && PRE_SCRIPTS='yes'
569 [ "$_opt_chroot_scripts_set" ]  && CHROOT_SCRIPTS='yes'
570 [ "$_opt_keep_src_list" ]       && KEEP_SRC_LIST='yes'
571 [ "$_opt_grmlrepos" ]           && GRMLREPOS='yes'
572 [ "$_opt_backportrepos" ]       && BACKPORTREPOS='yes'
573 [ "$_opt_hostname" ]            && HOSTNAME=$_opt_hostname
574 [ "$_opt_password" ]            && ROOTPASSWORD=$_opt_password
575 [ "$_opt_nopassword" ]          && NOPASSWORD='yes'
576 [ "$_opt_defaultinterfaces" ]   && USE_DEFAULT_INTERFACES="true"
577 [ "$_opt_nointerfaces" ]        && NOINTERFACES="true"
578 [ "$_opt_nokernel" ]            && NOKERNEL="true"
579 [ "$_opt_sshcopyid" ]           && SSHCOPYID="true"
580 [ "$_opt_sshcopyauth" ]         && SSHCOPYAUTH="true"
581 [ "$_opt_bootappend" ]          && BOOT_APPEND=$_opt_bootappend
582 [ "$_opt_grub" ]                && GRUB=$_opt_grub
583 [ "$_opt_efi" ]                 && EFI=$_opt_efi
584 [ "$_opt_arch" ]                && ARCH=$_opt_arch
585 [ "$_opt_insecure" ]            && echo "Warning: --insecure is deprecated, continuing anyway."
586 [ "$_opt_force" ]               && FORCE=$_opt_force
587 [ "$_opt_verbose" ]             && VERBOSE="-v"
588 [ "$_opt_debug" ]               && DEBUG="true"
589 [ "$_opt_remove_configs" ]      && REMOVE_CONFIGS="yes"
590
591 # make sure main is always included
592 [ -z "$COMPONENTS" ]            && COMPONENTS="main"
593 [ "$_opt_contrib" ]             && COMPONENTS="$COMPONENTS contrib"
594
595 case "${RELEASE}" in
596   jessie|stretch|buster|bullseye)
597     [ "$_opt_non_free" ] && COMPONENTS="$COMPONENTS non-free"
598     ;;
599   *)
600     [ "$_opt_non_free" ] && COMPONENTS="$COMPONENTS non-free-firmware non-free"
601     ;;
602 esac
603
604 # command line option checks
605 if [ "$_opt_scripts_set" ] ; then
606   ewarn "Deprecation NOTE: --scripts option is deprecated, please switch to --post-scripts instead."
607   SCRIPTS='yes' # deprecated since grml-debootstrap >=0.71
608 fi
609
610 if [ "$_opt_grub" ] && [ "$_opt_vmfile" ] ; then
611   eerror "The --grub option is incompatible with --vmfile, please drop it from your command line."
612   eerror "The --grub option is unneeded as GRUB will be installed automatically (unless GRUB_INSTALL='no')."
613   bailout 1
614 fi
615
616 if [ "${_opt_sshcopyid}" ] && [ "${_opt_sshcopyauth}" ] ; then
617   eerror "The --sshcopyid option is incompatible with --sshcopyauth, please drop either of them from your command line."
618   bailout 1
619 fi
620
621 if [ -n "$ISO" ] && [[ "$DEBOOTSTRAP" =~ mmdebstrap$ ]] ; then
622   eerror "The ISO option is incompatible with usage of mmdebstrap for bootstrapping."
623   eerror "Either drop the --iso ... option or use plain debootstrap instead."
624   bailout 1
625 fi
626
627 if [ "$DEBUG" = "true" ] ; then
628   set -x
629 fi
630
631 [ "$_opt_help" ] && {
632   usage
633   exit 0
634 }
635
636 [ "$_opt_version" ] && {
637   einfo "$PN - version $VERSION"
638   einfo "Report bugs via https://github.com/grml/grml-debootstrap/ or https://grml.org/bugs/"
639   exit 0
640 }
641 # }}}
642
643 # check for root permissions {{{
644 if ! check4root ; then
645    echo "For usage instructions please execute '$PN --help'."
646    bailout 1
647 fi
648 # }}}
649
650 # make sure we have what we need {{{
651 check4progs "${DEBOOTSTRAP}" || bailout 1
652
653 if [ -n "$VIRTUAL" ] ; then
654   check4progs kpartx parted qemu-img || bailout 1
655 fi
656 # }}}
657
658 # source specified configuration file {{{
659 if [ -n "$CONFIGFILE" ] ; then
660   einfo "Reading specified config file $CONFIGFILE."
661   # shellcheck disable=SC1091 source=config
662   if ! . "$CONFIGFILE" ; then
663     eerror "Error reading config file $CONFIGFILE" ; bailout 1
664   fi
665 fi
666 # }}}
667
668 # backwards compatibility checks {{{
669 if [ -n "$GROOT" ] ; then
670    eerror "Error: you seem to have \$GROOT configured."
671    eerror "This variable is no longer supported, please visit the"
672    eerror "grml-debootstrap documentation for details."
673    bailout 1
674 fi
675
676 if echo "$GRUB" | grep -q '^hd' ; then
677    eerror "Error: this syntax for the grub configuration variable is no longer supported."
678    eerror "Please do not use hd... any longer but /dev/sdX instead."
679    bailout 1
680 fi
681 # }}}
682
683 # welcome screen {{{
684 welcome_dialog()
685 {
686    dialog --title "$PN" --yesno "Welcome to the interactive configuration of ${PN}.
687 Do you want to continue installing Debian using this frontend?" 0 0 || bailout 0
688 }
689 # }}}
690
691 # ask for target {{{
692 prompt_for_target()
693 {
694   AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
695                sed 's/*//' | \
696                grep -v 'Extended$' | \
697                gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}'; ls /dev/md[0-9]* 2>/dev/null || true);
698
699   if [ -z "$AVAILABLE_PARTITIONS" ] ; then
700      dialog --title "$PN" --trim \
701      --msgbox "Sorry, no partitions found. Please configure your
702      harddisks (see /proc/partitions) using a tool like fdisk,
703      cfdisk, gpart, gparted,..." 0 0
704      bailout 1
705   fi
706
707   PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
708                      fs="$(blkid -s TYPE -o value "$i" 2>/dev/null)"
709                      [ -n "$fs" ] || fs='[no_filesystem_yet]'
710                      echo "$i" "$fs"
711                      unset fs
712                    done)
713
714   # shellcheck disable=SC2086
715   TARGET=$(dialog --title "$PN" --single-quoted --stdout \
716          --menu "Please select the target partition:" 0 0 0 \
717          $PARTITION_LIST)
718   [ $? -eq 0 ] || bailout 1
719 }
720 # }}}
721
722 # ask for bootmanager {{{
723 prompt_for_bootmanager()
724 {
725   ADDITIONAL_PARAMS=""
726
727   if echo "$TARGET" | grep -q "/dev/md" ; then
728      MBRPART="all disks of Software RAID $TARGET"
729   else
730      # figure out whole disk device
731      found=
732      for device in /dev/disk/by-id/*
733      do
734         [ "$(readlink -f "$device")" = "${TARGET}" ] || continue
735         found=1
736         break
737      done
738      # shellcheck disable=SC2001
739      [ -n "$found" ] && MBRDISK=$(echo "${device}" | sed -e 's/-part[0-9][0-9]*$//')
740      if [ -e "$MBRDISK" ]; then
741         MBRDISK=$(readlink -f "$MBRDISK")
742      else
743         # fall back to old behaviour
744         # shellcheck disable=SC2001
745         MBRDISK=$(echo "${TARGET}" | sed -e 's/[0-9][0-9]*$//')
746      fi
747
748      MBRPART="MBR of $MBRDISK"
749   fi
750
751   for device in cciss/c0d0 sda hda; do
752     if [ "/dev/$device" != "${MBRDISK}" ]; then
753       grep -q $device /proc/partitions && \
754       ADDITIONAL_PARAMS="$ADDITIONAL_PARAMS:$device:install bootmanager grub into MBR of /dev/$device"
755     fi
756   done
757   ADDITIONAL_PARAMS=${ADDITIONAL_PARAMS#:}
758
759   OIFS="$IFS"; IFS=:
760
761   # shellcheck disable=SC2086
762   GETMBR=$(dialog --stdout --title "$PN" --default-item mbr \
763           --menu "Where do you want to install the bootmanager grub?" 0 0 0 \
764             mbr       "install bootmanager into $MBRPART" \
765             nowhere   "do not install bootmanager at all" \
766           ${ADDITIONAL_PARAMS})
767   [ $? -eq 0 ] || bailout 3
768   IFS="$OIFS"
769
770   case "$GETMBR" in
771     mbr)
772       # /dev/md0: has to be installed in MBR of /dev/md0 and not in /dev/md:
773       if echo "$TARGET" | grep -q "/dev/md" ; then
774         GRUB="$TARGET"
775       else
776         GRUB="$MBRDISK"
777       fi
778       ;;
779     hda)
780       GRUB="/dev/hda"
781       ;;
782     sda)
783       GRUB="/dev/sda"
784       ;;
785     nowhere)
786       GRUB=''
787       ;;
788   esac
789 }
790 # }}}
791
792 # ask for Debian release {{{
793 prompt_for_release()
794 {
795   [ -n "$RELEASE" ] && DEFAULT_RELEASE="$RELEASE" || DEFAULT_RELEASE='bullseye'
796   RELEASE="$(dialog --stdout --title "${PN}" --default-item $DEFAULT_RELEASE --menu \
797             "Please enter the Debian release you would like to use for installation:" \
798             0 50 8 \
799             buster   Debian/10 \
800             bullseye Debian/11 \
801             bookworm Debian/12 \
802             sid      Debian/unstable)"
803   [ $? -eq 0 ] || bailout
804 }
805 # }}}
806
807 # ask for hostname {{{
808 prompt_for_hostname()
809 {
810   HOSTNAME="$(dialog --stdout --title "${PN}" --inputbox \
811             "Please enter the hostname you would like to use for installation:" \
812             0 0 "$HOSTNAME")"
813   [ $? -eq 0 ] || bailout
814 }
815 # }}}
816
817 # ask for password {{{
818 prompt_for_password()
819 {
820   if [ "$_opt_nopassword" ] ; then
821     einfo "Skip asking for root password as requested."
822     return 0
823   fi
824
825   ROOTPW1='PW1'
826   ROOTPW2='PW2'
827   while [ "$ROOTPW1" != "$ROOTPW2" ]; do
828     ROOTPW1=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
829     "Please enter the password for the root account:" 10 60)
830     [ $? -eq 0 ] || bailout
831
832     ROOTPW2=$(dialog --insecure --stdout --title "${PN}" --passwordbox \
833     "Please enter the password for the root account again for \
834     confirmation:" 10 60)
835     [ $? -eq 0 ] || bailout
836
837     if [ "$ROOTPW1" != "$ROOTPW2" ]; then
838       dialog --stdout --title "${PN}" --ok-label \
839         "Retry" --msgbox "Passwords do not match!" 10 60
840     fi
841   done
842   ROOTPASSWORD="$ROOTPW1"
843 }
844 # }}}
845
846 # ask for Debian mirror {{{
847 prompt_for_mirror()
848 {
849   [ -n "$ISO" ] && DEFAULT_MIRROR='local' || DEFAULT_MIRROR='net'
850
851   CHOOSE_MIRROR=$(dialog --stdout --title "$PN" --default-item $DEFAULT_MIRROR \
852           --menu "Where do you want to install from?" 0 0 0 \
853             net   "install via network (downloading from mirror)" \
854             local "install from local directory/mirror"
855           )
856   [ $? -eq 0 ] || bailout
857
858   if [ "$CHOOSE_MIRROR" = 'net' ] ; then
859      [ -n "$MIRROR" ] || MIRROR='http://deb.debian.org/debian'
860      MIRROR="$(dialog --stdout --title "${PN}" --inputbox \
861                "Please enter Debian mirror you would like to use for installing packages." \
862                0 0 $MIRROR)"
863      [ $? -eq 0 ] || bailout
864   else # CHOOSE_MIRROR == local
865      [ -n "$ISO" ] || ISO='/mnt/mirror'
866      ISO="$(dialog --stdout --title "${PN}" --inputbox \
867                "Please enter directory name you would like to use for installing packages." \
868                0 0 $ISO)"
869      [ $? -eq 0 ] || bailout
870   fi
871 }
872 # }}}
873
874 # software raid setup {{{
875 config_swraid_setup()
876 {
877 TMPFILE=$(mktemp)
878
879 # Currently we support only raid1:
880 RAIDLEVEL='raid1'
881
882 MD_LIST=$(for i in $(seq 0 9) ; do
883             awk '{print $4}' /proc/partitions | grep -q "md$i" || \
884             echo "/dev/md$i /dev/md$i"
885           done)
886
887 # shellcheck disable=SC2086
888 TARGET=$(dialog --stdout --title "$PN" --default-item /dev/md0 \
889 --menu "Which device do you want to use for ${RAIDLEVEL}?
890
891 Notice: activated devices will not be listed for security reasons. Anyway, please make sure the selected device is not in use already!" 0 0 0 \
892 $MD_LIST)
893 [ $? -eq 0 ] || bailout 20
894
895 AVAILABLE_PARTITIONS=$(LANG=C fdisk -l 2>/dev/null | \
896              sed 's/*//' | \
897              grep -v 'Extended$' | \
898              gawk -v num=0 -v ORS=' ' '/^\/dev\// {print $1}')
899 [ -n "$AVAILABLE_PARTITIONS" ] || echo "Fatal error: no partitions available?"
900 PARTITION_LIST=$(for i in $AVAILABLE_PARTITIONS ; do
901                      echo "$i $(blkid -s TYPE -o value "$i" 2>/dev/null || echo '[no_filesystem_yet]') off"
902                  done)
903
904 # shellcheck disable=SC2086
905 dialog --title "$PN" --separate-output \
906        --checklist "Please select the partitions you would like to use for your $RAIDLEVEL on ${TARGET}:" 0 0 0 \
907        $PARTITION_LIST 2>"$TMPFILE"
908 [ $? -eq 0 ] || bailout
909 SELECTED_PARTITIONS="$(cat "$TMPFILE")"
910
911 NUM_PARTITIONS=0
912 while IFS= read -r i; do
913   NUM_PARTITIONS=$(( NUM_PARTITIONS + 1 ))
914 done < "$TMPFILE"
915
916 ERRORFILE=$(mktemp)
917 # shellcheck disable=SC2086
918 yes | mdadm --create "${TARGET}" --level="${RAIDLEVEL}" \
919       --raid-devices="${NUM_PARTITIONS}" ${SELECTED_PARTITIONS} >/dev/null 2>$ERRORFILE
920 RC=$?
921 if [ "$RC" = 0 ] ; then
922    dialog --title "$PN" --msgbox \
923    "Creating $TARGET was successful." 0 0
924    rm -f "$TMPFILE" "$ERRORFILE"
925 else
926    dialog --title "$PN" --msgbox \
927    "There was an error setting up $TARGET:
928
929 $(cat "$ERRORFILE")
930
931 Exiting." 0 0
932    rm -f "$TMPFILE" "$ERRORFILE"
933    bailout 1
934 fi
935
936 }
937
938 prompt_for_swraid()
939 {
940 if dialog --stdout --title "$PN" \
941           --defaultno --yesno "Do you want to configure Software RAID?
942
943 Please notice that only RAID level 1 is supported by ${PN} currently. Configuration will take place using mdadm." 0 0 ; then
944   config_swraid_setup
945 fi
946 }
947 # }}}
948
949 # user should recheck his configuration {{{
950 # support full automatic installation:
951 checkforrun() {
952    dialog --timeout 10 --title "$PN" \
953           --yesno "Do you want to stop at this stage?
954
955 Notice: you are running ${PN} in non-interactive mode.
956 ${PN} will install Debian ${RELEASE} on ${TARGET}.
957 Last chance to quit. Timeout of 10 seconds running....
958
959 Do you want to stop now?" 0 0 2>/dev/null
960 }
961 # }}}
962
963 # format efi partition {{{
964 format_efi_partition() {
965   if [ -z "$EFI" ] ; then
966     return 0
967   fi
968
969   if ! [ -b "$EFI" ] ; then
970     eerror "Specified efi argument [$EFI] not a valid block device."
971     bailout 1
972   fi
973
974   if fsck.vfat -bn "$EFI" >/dev/null; then
975     einfo "EFI partition $EFI seems to have a FAT filesystem, not modifying."
976   else
977     einfo "EFI partition $EFI doesn't seem to be formatted, creating filesystem."
978     mkfs.fat -F32 -n "EFI" "$EFI"
979     RC=$?
980     if [ ! $RC -eq 0 ] ; then
981       eerror "Error while creating filesystem on ${EFI}."
982       bailout 1
983     fi
984   fi
985 }
986 # }}}
987
988 # check for EFI support or try to enable it {{{
989 efi_support() {
990   local efivars_loaded=false
991   # this is for kernels versions before v3.10, which didn't provide efivarfs yet
992   if modprobe efivars &>/dev/null ; then
993     efivars_loaded=true
994   fi
995   # kernel versions v3.10 and newer usually provide efivarfs
996   if modprobe efivarfs &>/dev/null ; then
997     efivars_loaded=true
998   fi
999
1000   if [ -d /sys/firmware/efi ] ; then
1001     einfo "EFI support detected."
1002     return 0
1003   fi
1004
1005   if ! [ -d /sys/firmware/efi ] && [ "${efivars_loaded:-}" = "true" ] ; then
1006     einfo "EFI support detected, but system seems to be running in BIOS mode."
1007   fi
1008
1009   return 1
1010 }
1011 # }}}
1012
1013 # make sure the user is aware of the used configuration {{{
1014 checkconfiguration()
1015 {
1016
1017 if [ -z "$VIRTUAL" ] ; then
1018   if efi_support ; then
1019     if [ -z "$_opt_efi" ] ; then
1020       ewarn "EFI support detected but no --efi option given, please consider enabling it."
1021     fi
1022   else
1023     if [ -n "$_opt_efi" ] ; then
1024       eerror "EFI option used but no EFI support detected."
1025       bailout 1
1026     fi
1027   fi
1028 fi
1029
1030 if [ -n "$AUTOINSTALL" ] ; then
1031    if checkforrun ; then
1032       eerror "Exiting as requested"
1033       bailout 1
1034    fi
1035 elif [ -n "$INTERACTIVE" ] ; then
1036
1037    INFOTEXT="Please recheck configuration before execution:
1038    "
1039    [ -n "$TARGET" ]  && INFOTEXT="$INFOTEXT
1040    Target:          $TARGET"
1041    [ -n "$GRUB" ]    && INFOTEXT="$INFOTEXT
1042    Install grub:    $GRUB"
1043    [ -n "$EFI" ]    && INFOTEXT="$INFOTEXT
1044    Install efi:     $EFI"
1045    [ -n "$RELEASE" ] && INFOTEXT="$INFOTEXT
1046    Using release:   $RELEASE"
1047    [ -n "$HOSTNAME" ] && INFOTEXT="$INFOTEXT
1048    Using hostname:  $HOSTNAME"
1049    [ -n "$MIRROR" ]  && INFOTEXT="$INFOTEXT
1050    Using mirror:    $MIRROR"
1051    [ -n "$ISO" ]  && INFOTEXT="$INFOTEXT
1052    Using ISO:       $ISO"
1053    [ -n "$ARCH" ]  && INFOTEXT="$INFOTEXT
1054    Using arch:      $ARCH"
1055    [ -n "$CONFFILES" ] && INFOTEXT="$INFOTEXT
1056    Config files:    $CONFFILES"
1057
1058    INFOTEXT="$INFOTEXT
1059
1060 Is this ok for you? Notice: selecting 'No' will exit ${PN}."
1061
1062    dialog --title "$PN" --no-collapse \
1063           --yesno "$INFOTEXT" 0 0
1064    [ $? -eq 0 ] || bailout 0
1065
1066 else # if not running automatic installation display configuration and prompt for execution:
1067    einfo "$PN [${VERSION}] - Please recheck configuration before execution:"
1068    echo
1069    echo "   Target:          $TARGET"
1070
1071    # do not display if MNTPOINT is the default one
1072    case "$MNTPOINT" in /mnt/debootstrap*) ;; *) echo "   Mount point:     $MNTPOINT" ;; esac
1073
1074    if [ -n "$VIRTUAL" ] && [ "$GRUB_INSTALL" = 'yes' ] ; then
1075       echo "   Install grub:    yes"
1076       [ -n "$VMEFI" ]   && echo "   Install efi:     yes"   || echo "   Install efi:     no"
1077    else
1078      [ -n "$GRUB" ]     && echo "   Install grub:    $GRUB" || echo "   Install grub:    no"
1079      [ -n "$EFI" ]      && echo "   Install efi:     $EFI"  || echo "   Install efi:     no"
1080    fi
1081
1082    [ -n "$RELEASE" ]   && echo "   Using release:   $RELEASE"
1083    [ -n "$HOSTNAME" ]  && echo "   Using hostname:  $HOSTNAME"
1084    [ -n "$MIRROR" ]    && echo "   Using mirror:    $MIRROR"
1085    [ -n "$ISO" ]       && echo "   Using ISO:       $ISO"
1086    [ -n "$ARCH" ]      && echo "   Using arch:      $ARCH"
1087    [ -n "$CONFFILES" ] && echo "   Config files:    $CONFFILES"
1088    if [ -n "$VIRTUAL" ] ; then
1089       echo "   Deploying as Virtual Machine."
1090       if [ -n "$VMSIZE" ] && [ -n "$VMFILE" ]; then
1091          echo "   Using Virtual Disk file with size of ${VMSIZE}."
1092       fi
1093    fi
1094
1095    if [ ! -t 0 ] && [ -z "$ROOTPASSWORD" ] && [ -z "$NOPASSWORD" ] ; then
1096       echo
1097       echo "   You do not have a TTY allocated, your password will be shown in"
1098       echo "   plaintext on the terminal! If you are using SSH, try its -t option!"
1099    fi
1100
1101    echo
1102    echo "   Important! Continuing will delete all data from ${TARGET}!"
1103
1104    if [ -n "$FORCE" ] ; then
1105      einfo "Skip user acknowledgement as requested via --force option."
1106    else
1107      echo
1108      einfon "Is this ok for you? [y/N] "
1109      read -r a
1110      if ! [ "$a" = 'y' ] || [ "$a" = 'Y' ] ; then
1111         eerror "Exiting as requested."
1112         bailout 1
1113      fi
1114    fi
1115 fi
1116 }
1117 # }}}
1118
1119 # interactive mode {{{
1120 interactive_mode()
1121 {
1122   check4progs dialog || bailout 1
1123
1124   welcome_dialog
1125
1126   prompt_for_release
1127
1128   prompt_for_swraid
1129
1130   prompt_for_target
1131
1132   prompt_for_bootmanager
1133
1134   prompt_for_hostname
1135
1136   prompt_for_password
1137
1138   prompt_for_mirror
1139 }
1140
1141 # run interactive mode if we didn't get the according configuration yet
1142 if [ -z "$TARGET" ] || [ -n "$INTERACTIVE" ] ; then
1143    # only target might be unset, so make sure the INTERACTIVE flag is set as well
1144    INTERACTIVE=1
1145    interactive_mode
1146 fi
1147 # }}}
1148
1149 # architecture setup {{{
1150 if [ -n "$ARCH" ] ; then
1151    ARCHCMD="--arch $ARCH"
1152    ARCHINFO=" (${ARCH})"
1153 else
1154    ARCH="$(dpkg --print-architecture)"
1155    ARCHCMD="--arch $ARCH"
1156    ARCHINFO=" (${ARCH})"
1157 fi
1158
1159 if [ -z "${ARCH:-}" ] ; then
1160   eerror 'Architecture neither set (environment variable ARCH), nor could be automatically identified (using dpkg).'
1161   eerror 'Consider setting the --arch ... option.'
1162   bailout 1
1163 fi
1164 # }}}
1165
1166 # It is not possible to build amd64 on i686. {{{
1167 CURRENT_ARCH="$(uname -m)"
1168 if [ "$CURRENT_ARCH" != "x86_64" ] ; then
1169    if [ "$ARCH" = "amd64" ] ; then
1170       eerror "It is not possible to build amd64 on $CURRENT_ARCH. Consider installing and booting the 'linux-image-amd64' kernel or using '--arch i386' instead."
1171       bailout 1
1172    fi
1173 fi
1174 # }}}
1175
1176 # Support for generic release codenames is unavailable. {{{
1177 if [ "$RELEASE" = "stable" ] || [ "$RELEASE" = "testing" ] ; then
1178    eerror "Generic release codenames (stable, testing) are unsupported. \
1179 Please use specific codenames such as bullseye or bookworm."
1180    bailout 1
1181 fi
1182 # }}}
1183
1184 checkconfiguration
1185
1186 # finally make sure at least $TARGET is set [the partition for the new system] {{{
1187 if [ -n "$TARGET" ] ; then
1188    SHORT_TARGET="${TARGET##*/}"
1189 else
1190    eerror "Please adjust $CONFFILES/config or..."
1191    eerror "... use the interactive version for configuration before running ${0}"
1192    bailout 1
1193 fi
1194 # }}}
1195
1196 # stages setup {{{
1197 if [ -z "$STAGES" ] ; then
1198    STAGES="/var/cache/grml-debootstrap/stages_${SHORT_TARGET}"
1199    [ -d "$STAGES" ] || mkdir -p "$STAGES"
1200 fi
1201
1202 if [ -r "$STAGES"/grml-debootstrap ] ; then
1203    if grep -q 'done' "${STAGES}/grml-debootstrap" ; then
1204       eerror "Error: grml-debootstrap has been executed already, won't continue therefore."
1205       eerror "If you want to re-execute grml-debootstrap just manually remove ${STAGES}"
1206    fi
1207 fi
1208 # }}}
1209
1210 # partition handling {{{
1211 PARTITION=''
1212 DIRECTORY=''
1213
1214 set_target_directory(){
1215     # assume we are installing into a directory, don't run mkfs and grub related stuff therefore
1216     DIRECTORY=1
1217     MNTPOINT="$TARGET"
1218     MKFS=''
1219     TUNE2FS=''
1220     FSCK=''
1221     # make sure we normalise the path to an absolute directory name so something like:
1222     #  mkdir -p foo/a bar/a; (cd foo; grml-debootstrap -t a)&; (cd bar; grml-debootstrap -t a)&; wait
1223     # works
1224     TARGET="$(readlink -f "$TARGET")"
1225 }
1226
1227 if [ -b "$TARGET" ] || [ -n "$VIRTUAL" ] ; then
1228     PARTITION=1
1229 else
1230     # $TARGET was not detected as block device, but we do not want to create target directory in /dev/
1231     if [[ $TARGET == "/dev/"* ]]; then
1232       eerror "Error: Will not create target directory $TARGET in /dev."
1233       eerror "  Please check the partition(s) of the blockdevice."
1234       bailout 1
1235     fi
1236     set_target_directory
1237 fi
1238 # }}}
1239
1240 # make sure we have the right syntax when using an iso image {{{
1241 if [ -n "$ISO" ] ; then
1242    case $ISO in
1243       file*) # do nothing
1244       ;;
1245       *)
1246       ISO=file:$ISO
1247       ;;
1248    esac
1249 fi
1250 ISODIR=${ISO##file:}
1251 ISODIR=${ISODIR%%/}
1252 # }}}
1253
1254 # Debian ISOs do not contain signed Release files {{{
1255 if [ -n "$ISO" ] ; then
1256     DEBOOTSTRAP_OPT="$DEBOOTSTRAP_OPT --no-check-gpg"
1257 fi
1258 # }}}
1259
1260 # create filesystem {{{
1261 mkfs() {
1262   if [ -n "$DIRECTORY" ] ; then
1263      einfo "Running grml-debootstrap on a directory, skipping mkfs stage."
1264      return 0
1265   fi
1266
1267   if grep -q "$TARGET" /proc/mounts ; then
1268     eerror "$TARGET already mounted, exiting to avoid possible damage. (Manually unmount $TARGET)"
1269     bailout 1
1270   fi
1271
1272   # mkfs.ext* might prompt with "/dev/sdX# contains a ext* file system
1273   # created on ... Proceed anyway? (y,n)" which we want to skip in force mode
1274   if [ -n "$MKFS" ] && [ -n "$FORCE" ] ; then
1275     case "$MKFS" in
1276       mkfs.ext*)
1277         einfo "Enabling force option (-F) for mkfs.ext* tool as requested via --force switch."
1278         MKFS_OPTS="$MKFS_OPTS -F"
1279         ;;
1280     esac
1281   fi
1282
1283   # starting with e2fsprogs 1.43~WIP.2015.05.18-1 mkfs.ext4 enables the metadata_csum feature
1284   # by default, which requires a recent version of tune2fs on the target system then,
1285   # so disable this feature for older Debian releases where it's known to be unsupported
1286   if [ -n "$MKFS" ] && [ "$MKFS" = "mkfs.ext4" ] ; then
1287     case "$RELEASE" in
1288       jessie)
1289         # assume a more recent version if we can't identify the version via dpkg-query
1290         local e2fsprogs_version
1291         e2fsprogs_version="$(dpkg-query --show --showformat='${Version}' e2fsprogs 2>/dev/null || echo 1.44)"
1292         if [ -n "$e2fsprogs_version" ] && dpkg --compare-versions "$e2fsprogs_version" ge '1.43~WIP.2015.05.18-1' ; then
1293           einfo "Disabling metadata_csum feature for $MKFS as $RELEASE doesn't support it."
1294           MKFS_OPTS="$MKFS_OPTS -O ^metadata_csum"
1295         fi
1296         ;;
1297     esac
1298   fi
1299
1300   # starting with e2fsprogs v1.47.0 mkfs.ext4 enables the metadata_csum_seed feature
1301   # by default, which requires Linux kernel >=4.4, e2fsprogs >=1.43, according GRUB etc.
1302   # Disable this feature for Debian releases older than bookworm
1303   if [ -n "$MKFS" ] && [ "$MKFS" = "mkfs.ext4" ] ; then
1304     case "$RELEASE" in
1305       jessie|stretch|buster|bullseye)
1306         local e2fsprogs_version
1307         # assume a more recent version if we can't identify the version via dpkg-query
1308         e2fsprogs_version="$(dpkg-query --show --showformat='${Version}' e2fsprogs 2>/dev/null || echo 1.47)"
1309         if [ -n "$e2fsprogs_version" ] && dpkg --compare-versions "$e2fsprogs_version" ge '1.43' ; then
1310           einfo "Disabling metadata_csum_seed feature for $MKFS as $RELEASE doesn't support it."
1311           MKFS_OPTS="$MKFS_OPTS -O ^metadata_csum_seed"
1312         fi
1313         ;;
1314     esac
1315   fi
1316
1317   if [ -n "$MKFS" ] ; then
1318
1319     if [ -n "${ARM_EFI_TARGET}" ] ; then
1320       einfo "Running mkfs.fat $MKFS_OPTS on $ARM_EFI_TARGET"
1321       mkfs.fat -n "EFI" "$ARM_EFI_TARGET"
1322       MKFS_OPTS="$MKFS_OPTS -L LINUX"
1323     fi
1324
1325     einfo "Running $MKFS $MKFS_OPTS on $TARGET"
1326     # shellcheck disable=SC2086
1327     "$MKFS" $MKFS_OPTS "$TARGET" ; RC=$?
1328
1329     if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
1330       if ! echo "$MKFS" | grep -q "mkfs.ext" ; then
1331         eerror "Not changing disk uuid for $TARGET because $MKFS doesn't seem to match for ext{2,3,4} file system"
1332         bailout 1
1333       else
1334         einfo "Changing disk uuid for $TARGET to fixed (non-random) value $DISK_IDENTIFIER using tune2fs"
1335         tune2fs "$TARGET" -U "$DISK_IDENTIFIER" </dev/null
1336       fi
1337     fi
1338
1339     if [ -n "$VIRTUAL" ] && [ -n "$EFI_TARGET" ]; then
1340       einfo "Creating FAT filesystem on $EFI_TARGET"
1341       mkfs.fat -F32 -n "EFI" "$EFI_TARGET"
1342     fi
1343
1344     # make sure /dev/disk/by-uuid/... is up2date, otherwise grub
1345     # will fail to detect the uuid in the chroot
1346     if [ -n "$VIRTUAL" ] ; then
1347       einfo "Virtual environment doesn't require blockdev --rereadpt, skipping therefore"
1348     elif echo "$TARGET" | grep -q "/dev/md" ; then
1349       blockdev --rereadpt "${TARGET}"
1350     else
1351       # if we deploy to /dev/sdX# then let's see if /dev/sdX exists
1352       local main_device="${TARGET%%[0-9]*}"
1353       # sanity check to not try to e.g. access /dev/loop if we get /dev/loop0
1354       if [ -f "/sys/block/$(basename "${main_device}")/$(basename "${TARGET}")/dev" ] ; then
1355         blockdev --rereadpt "$main_device"
1356       else
1357         einfo "No underlying block device for $TARGET identified, skipping blockdev --rereadpt."
1358       fi
1359     fi
1360     # give the system 2 seconds, otherwise we might run into
1361     # race conditions :-/
1362     sleep 2
1363
1364     eend $RC
1365   fi
1366 }
1367 # }}}
1368
1369 # retrieve ID_FS_UUID {{{
1370 identify_target_uuid() {
1371   local device="$1"
1372
1373   if ! [ -b "$device" ] ; then
1374     return 1
1375   fi
1376
1377   eval "$(blkid -o udev "$1" 2>/dev/null)"
1378
1379   if [ -n "$ID_FS_UUID" ] ; then
1380     echo "$ID_FS_UUID"
1381   else
1382     return 1
1383   fi
1384 }
1385 # }}}
1386
1387 # identify TARGET_UUID {{{
1388 mountpoint_to_blockdevice() {
1389   TARGET_UUID=''
1390
1391   TARGET_UUID=$(identify_target_uuid "$TARGET" 2>/dev/null || true)
1392   if [ -n "$TARGET_UUID" ] ; then
1393     einfo "Identified UUID $TARGET_UUID for $TARGET"
1394     return 0
1395   fi
1396
1397   # $TARGET might be a mountpoint and not a blockdevice, search for according entry
1398   for file in /sys/block/*/*/dev ; do
1399     if grep -q "^$(mountpoint -d "${TARGET}")$" "$file" ; then
1400       local dev
1401       dev="${file%/dev}"
1402       dev="/dev/${dev##*/}"
1403       TARGET_UUID=$(identify_target_uuid "$dev" 2>/dev/null || true)
1404
1405       if [ -n "$TARGET_UUID" ] ; then
1406         einfo "Identified UUID $TARGET_UUID for $TARGET (via $file)"
1407         return 0
1408       fi
1409     fi
1410   done
1411 }
1412 # }}}
1413
1414 # modify filesystem settings {{{
1415 tunefs() {
1416   if [ -n "$TUNE2FS" ] && echo "$MKFS" | grep -q "mkfs.ext" ; then
1417      einfo "Disabling automatic filesystem check on $TARGET via tune2fs"
1418      $TUNE2FS "$TARGET" </dev/null
1419   fi
1420 }
1421 # }}}
1422
1423 # mount the new partition or if it's a directory do nothing at all {{{
1424 mount_target() {
1425   if [ -n "$DIRECTORY" ] ; then
1426      einfo "Running grml-debootstrap on a directory, nothing to mount."
1427   else
1428      if grep -q "$TARGET" /proc/mounts ; then
1429         ewarn "$TARGET already mounted, continuing anyway."
1430      else
1431        if ! [ -d "${MNTPOINT}" ] ; then
1432           [ -n "$VIRTUAL" ] || mkdir -p "${MNTPOINT}"
1433        fi
1434        einfo "Mounting $TARGET to $MNTPOINT"
1435        mkdir -p "$MNTPOINT"
1436        mount -o rw,suid,dev "$TARGET" "$MNTPOINT"
1437      fi
1438   fi
1439   if [ -n "$ISODIR" ] ; then
1440      einfo "Mounting Debian image loopback to $MNTPOINT/$ISODIR."
1441      mkdir -p "$MNTPOINT/$ISODIR"
1442      mount --bind "$ISODIR" "$MNTPOINT/$ISODIR"
1443   fi
1444 }
1445 # }}}
1446
1447 # prepare VM image for usage with debootstrap {{{
1448 prepare_vm() {
1449   if [ -z "$VIRTUAL" ] ; then
1450      return 0 # be quiet by intention
1451   fi
1452
1453   if [ -b "$TARGET" ] && [ -n "$VMFILE" ] ; then
1454      eerror "Error: specified virtual disk target ($TARGET) is an existing block device."
1455      bailout 1
1456   fi
1457   if [ ! -b "$TARGET" ] && [ -z "$VMFILE" ] ; then
1458      eerror "Error: specified virtual disk target ($TARGET) does not exist yet."
1459      bailout 1
1460   fi
1461
1462   # make sure loop module is present and a usable loop device exists
1463   modprobe -q loop
1464   if ! losetup -f >/dev/null 2>&1; then
1465     eerror "Error finding usable loop device"
1466     bailout 1
1467   fi
1468
1469   # if dm-mod isn't available then kpartx will fail with
1470   # "Is device-mapper driver missing from kernel? [...]"
1471   modprobe -q dm-mod
1472   if ! grep -q 'device-mapper' /proc/misc >/dev/null 2>&1 ; then
1473     eerror "Device-mapper support missing in kernel."
1474     bailout 1
1475   fi
1476
1477   ORIG_TARGET="$TARGET" # store for later reuse
1478
1479   if [ -n "$VMFILE" ]; then
1480     qemu-img create -f raw "${TARGET}" "${VMSIZE}"
1481   fi
1482   if [ -n "$VMEFI" ]; then
1483     parted -s "${TARGET}" 'mklabel gpt'
1484     parted -s "${TARGET}" 'mkpart ESP fat32 1MiB 101MiB'
1485     parted -s "${TARGET}" 'set 1 boot on'
1486     parted -s "${TARGET}" 'mkpart bios_grub 101MiB 102MiB'
1487     parted -s "${TARGET}" 'set 2 bios_grub on'
1488     parted -s "${TARGET}" 'mkpart primary ext4 102MiB 100%'
1489
1490   else
1491     # arm64 support largely only exists for GPT
1492     if [ "$ARCH" = 'arm64' ]; then
1493       einfo "Setting up GPT partitions for arm64"
1494       parted -s "${TARGET}" 'mklabel gpt'
1495       parted -s "${TARGET}" 'mkpart EFI fat32 1MiB 10MiB'
1496       parted -s "${TARGET}" 'set 1 boot on'
1497       parted -s "${TARGET}" 'mkpart LINUX ext4 10MiB 100%'
1498     else
1499       parted -s "${TARGET}" 'mklabel msdos'
1500       if [ "$FIXED_DISK_IDENTIFIERS" = "yes" ] ; then
1501         einfo "Adjusting disk signature to a fixed (non-random) value"
1502         MBRTMPFILE=$(mktemp)
1503         dd if="${TARGET}" of="${MBRTMPFILE}" bs=512 count=1
1504         echo -en "\\x41\\x41\\x41\\x41" | dd of="${MBRTMPFILE}" conv=notrunc seek=440 bs=1
1505         dd if="${MBRTMPFILE}" of="${TARGET}" conv=notrunc
1506       fi
1507       parted -s "${TARGET}" 'mkpart primary ext4 4MiB 100%'
1508       parted -s "${TARGET}" 'set 1 boot on'
1509     fi
1510   fi
1511
1512   DEVINFO=$(kpartx -asv "$TARGET") # e.g. 'add map loop0p1 (254:5): 0 20477 linear 7:0 3' - will be multi-line for arm64
1513   if [ -z "${DEVINFO}" ] ; then
1514     eerror "Error setting up loopback device."
1515     bailout 1
1516   fi
1517
1518   # if we're building for arm64, we operate on the first line of $DEVINFO which is the EFI partition
1519   if [ "$ARCH" = 'arm64' ]; then
1520     LOOP_PART="${DEVINFO##add map }" # 'loop0p1 (254:5): 0 20477 linear 7:0 3'
1521     LOOP_PART="${LOOP_PART// */}"    # 'loop0p1'
1522     LOOP_DISK="${LOOP_PART%p*}"      # 'loop0'
1523     export ARM_EFI_TARGET="/dev/mapper/$LOOP_PART"
1524     DEVINFO=${DEVINFO##*$'\n'} # now set $DEVINFO to the last line which is the OS partition
1525   fi
1526
1527   # hopefully this always works as expected
1528   LOOP_PART="${DEVINFO##add map }" # 'loop0p1 (254:5): 0 20477 linear 7:0 3'
1529   LOOP_PART="${LOOP_PART// */}"    # 'loop0p1'
1530   if [ -n "$VMEFI" ]; then
1531     export EFI_TARGET="/dev/mapper/$LOOP_PART" # '/dev/mapper/loop0p1'
1532     LOOP_PART="${LOOP_PART%p1}p3"
1533   fi
1534   LOOP_DISK="${LOOP_PART%p*}"      # 'loop0'
1535   export TARGET="/dev/mapper/$LOOP_PART" # '/dev/mapper/loop0p1'
1536
1537   if [ -z "$TARGET" ] ; then
1538      eerror "Error: target could not be set to according /dev/mapper/* device."
1539      bailout 1
1540   fi
1541 }
1542 # }}}
1543
1544 # make VM image bootable {{{
1545 grub_install() {
1546   if [ -z "${VIRTUAL}" ] ; then
1547      return 0
1548   fi
1549   if [ "${GRUB_INSTALL}" != "yes" ] ; then
1550     einfo "Not installing GRUB as requested via \$GRUB_INSTALL=$GRUB_INSTALL"
1551     return 0
1552   fi
1553
1554   if ! mount "${TARGET}" "${MNTPOINT}" ; then
1555     eerror "Error: Mounting ${TARGET} failed, can not continue."
1556     bailout 1
1557   fi
1558
1559   if [ -n "${ARM_EFI_TARGET}" ]; then
1560     mkdir -p "${MNTPOINT}/boot/efi"
1561     if ! mount "${ARM_EFI_TARGET}" "${MNTPOINT}/boot/efi" ; then
1562       eerror "Error: Mounting ${ARM_EFI_TARGET} failed, can not continue."
1563       bailout 1
1564     fi
1565   fi
1566
1567   mount -t proc none "${MNTPOINT}"/proc
1568   mount -t sysfs none "${MNTPOINT}"/sys
1569   mount -t devtmpfs udev "${MNTPOINT}"/dev
1570   mount -t devpts devpts "${MNTPOINT}"/dev/pts
1571
1572   if [ -n "$ARM_EFI_TARGET" ]; then
1573     einfo "Installing Grub as bootloader into EFI."
1574
1575     chroot "${MNTPOINT}" grub-install --target=arm64-efi --efi-directory=/boot/efi --bootloader-id=debian --recheck --no-nvram --removable
1576   # Has chroot-script installed GRUB to MBR using grub-install (successfully), already?
1577   # chroot-script skips installation for unset ${GRUB}
1578   elif [[ -z "${GRUB}" ]] || ! dd if="${GRUB}" bs=512 count=1 2>/dev/null | cat -v | grep -Fq GRUB; then
1579     einfo "Installing Grub as bootloader."
1580
1581     if ! chroot "${MNTPOINT}" dpkg --list grub-pc 2>/dev/null | grep -q '^ii' ; then
1582       echo "Notice: grub-pc package not present yet, installing it therefore."
1583       # shellcheck disable=SC2086
1584       DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-pc
1585     fi
1586
1587     mkdir -p "${MNTPOINT}/boot/grub"
1588     if ! [ -d "${MNTPOINT}"/usr/lib/grub/i386-pc/ ] ; then
1589       eerror "Error: grub not installed inside Virtual Machine. Can not install bootloader."
1590       bailout 1
1591     fi
1592     cp -a "${MNTPOINT}"/usr/lib/grub/i386-pc "${MNTPOINT}/boot/grub/"
1593
1594     if [ -n "$VMEFI" ]; then
1595
1596       mkdir -p "${MNTPOINT}"/boot/efi
1597       mount -t vfat "${EFI_TARGET}" "${MNTPOINT}"/boot/efi
1598
1599       if ! chroot "${MNTPOINT}" dpkg --list shim-signed 2>/dev/null | grep -q '^ii' ; then
1600         echo "Notice: shim-signed package not present yet, installing it therefore."
1601         # shellcheck disable=SC2086
1602         DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS shim-signed
1603       fi
1604
1605       if [ "$(dpkg --print-architecture)" = "arm64" ]; then
1606         if ! chroot "${MNTPOINT}" dpkg --list grub-efi-arm64-signed 2>/dev/null | grep -q '^ii' ; then
1607           echo "Notice: grub-efi-arm64-signed package not present yet, installing it therefore."
1608           # shellcheck disable=SC2086
1609           DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-efi-arm64-bin grub-efi-arm64-signed
1610         fi
1611         chroot "$MNTPOINT" grub-install --target=arm64-efi --efi-directory=/boot/efi --uefi-secure-boot --removable "/dev/$LOOP_DISK"
1612       elif [ "$(dpkg --print-architecture)" = "i386" ]; then
1613         if ! chroot "${MNTPOINT}" dpkg --list grub-efi-ia32-signed 2>/dev/null | grep -q '^ii' ; then
1614           echo "Notice: grub-efi-ia32-signed package not present yet, installing it therefore."
1615           # shellcheck disable=SC2086
1616           DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-efi-ia32-bin grub-efi-ia32-signed
1617         fi
1618         chroot "$MNTPOINT" grub-install --target=i386-efi --efi-directory=/boot/efi --uefi-secure-boot --removable "/dev/$LOOP_DISK"
1619         chroot "$MNTPOINT" grub-install --target=i386-pc "/dev/$LOOP_DISK"
1620       else
1621         if ! chroot "${MNTPOINT}" dpkg --list grub-efi-amd64-signed 2>/dev/null | grep -q '^ii' ; then
1622           echo "Notice: grub-efi-amd64-signed package not present yet, installing it therefore."
1623           # shellcheck disable=SC2086
1624           DEBIAN_FRONTEND=$DEBIAN_FRONTEND chroot "$MNTPOINT" apt-get -y --no-install-recommends install $DPKG_OPTIONS grub-efi-amd64-bin grub-efi-amd64-signed
1625         fi
1626         chroot "$MNTPOINT" grub-install --target=x86_64-efi --efi-directory=/boot/efi --uefi-secure-boot --removable "/dev/$LOOP_DISK"
1627         chroot "$MNTPOINT" grub-install --target=i386-pc "/dev/$LOOP_DISK"
1628       fi
1629     else
1630       dd if="${MNTPOINT}/usr/lib/grub/i386-pc/boot.img" of="${ORIG_TARGET}" conv=notrunc bs=440 count=1
1631       case "${_opt_filesystem}" in
1632         f2fs)
1633           chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos f2fs
1634           ;;
1635         xfs)
1636           chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos xfs
1637           ;;
1638         # NOTE - we might need to distinguish between further filesystems
1639         *)
1640           chroot "${MNTPOINT}" grub-mkimage -O i386-pc -p "(hd0,msdos1)/boot/grub" -o /tmp/core.img biosdisk part_msdos ext2
1641           ;;
1642       esac
1643
1644       dd if="${MNTPOINT}/tmp/core.img" of="${ORIG_TARGET}" conv=notrunc seek=1
1645       rm -f "${MNTPOINT}/tmp/core.img"
1646     fi
1647   fi
1648
1649   # workaround for Debian bug #918590 with lvm + udev:
1650   # WARNING: Device /dev/... not initialized in udev database even after waiting 10000000 microseconds
1651   if [ -d /run/udev ] ; then
1652     einfo "Setting up bind-mount /run/udev"
1653     mkdir -p "${MNTPOINT}"/run/udev
1654     mount --bind /run/udev "${MNTPOINT}"/run/udev
1655   fi
1656
1657   if [ -n "${BOOT_APPEND}" ] ; then
1658     echo "Adding BOOT_APPEND configuration ['${BOOT_APPEND}'] to /etc/default/grub."
1659     sed -i "/GRUB_CMDLINE_LINUX_DEFAULT/ s#\"\$# ${BOOT_APPEND}\"#" "${MNTPOINT}/etc/default/grub"
1660   fi
1661
1662   einfo "Updating grub configuration file."
1663   chroot "${MNTPOINT}" update-grub
1664   chroot "${MNTPOINT}" sync
1665
1666   case "$RELEASE" in
1667     jessie)
1668       einfo "Applying workaround for GRUB font path bug in jessie (Debian #787685)."
1669       mkdir -p "${MNTPOINT}/boot/grub/fonts/"
1670       cp "${MNTPOINT}/usr/share/grub/unicode.pf2" "${MNTPOINT}/boot/grub/fonts/"
1671       ;;
1672   esac
1673
1674   if grep -q '^GRUB_DISABLE_LINUX_UUID=.*true' "${MNTPOINT}"/etc/default/grub 2>/dev/null ; then
1675     ewarn "GRUB_DISABLE_LINUX_UUID is set to true in /etc/default/grub, not adjusting root= in grub.cfg."
1676     ewarn "Please note that your system might NOT be able to properly boot."
1677   elif [ -z "$ARM_EFI_TARGET" ]; then
1678     einfo "Adjusting grub.cfg for successful boot sequence."
1679     sed -i "s;root=[^ ]\\+;root=UUID=$TARGET_UUID;" "${MNTPOINT}"/boot/grub/grub.cfg
1680   fi
1681
1682   # workaround for Debian bug #918590 with lvm + udev:
1683   # WARNING: Device /dev/... not initialized in udev database even after waiting 10000000 microseconds
1684   if mountpoint "${MNTPOINT}"/run/udev &>/dev/null ; then
1685     einfo "Unmounting bind-mount /run/udev"
1686     umount "${MNTPOINT}"/run/udev
1687   fi
1688
1689   umount "${MNTPOINT}"/proc
1690   umount "${MNTPOINT}"/sys
1691   umount "${MNTPOINT}"/dev/pts
1692   try_umount 3 "${MNTPOINT}"/dev
1693
1694   if [ -n "$VMEFI" ]; then
1695     umount "${MNTPOINT}"/boot/efi
1696   fi
1697
1698 }
1699 # }}}
1700
1701 # unmount VM image {{{
1702 umount_target() {
1703   if [ -z "${VIRTUAL}" ] ; then
1704      return 0
1705   fi
1706
1707   if [ -n "${ARM_EFI_TARGET}" ]; then
1708     umount "${MNTPOINT}/boot/efi"
1709   fi
1710
1711   umount "${MNTPOINT}"
1712   kpartx -d "${ORIG_TARGET}" >/dev/null
1713   # Workaround for a bug in kpartx which doesn't clean up properly,
1714   # see Debian Bug #891077 and Github-PR grml/grml-debootstrap#112
1715   if dmsetup ls | grep -q "^${LOOP_PART} "; then
1716     kpartx -d "/dev/${LOOP_DISK}" >/dev/null
1717   fi
1718 }
1719 # }}}
1720
1721 # install main chroot {{{
1722 debootstrap_system() {
1723   if [ "$_opt_nodebootstrap" ]; then
1724      einfo "Skipping debootstrap as requested."
1725      return
1726   fi
1727
1728   if grep -q "$MNTPOINT" /proc/mounts || [ -n "$DIRECTORY" ] ; then
1729     :
1730   else
1731     eerror "Error: $MNTPOINT not mounted, can not continue."
1732     eend 1 ; exit 1
1733   fi
1734
1735   if [ -n "$ISO" ] ; then
1736     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${ISO}"
1737     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $ISO"
1738     # shellcheck disable=SC2086
1739     "$DEBOOTSTRAP" $ARCHCMD $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$ISO"
1740     RC=$?
1741   else
1742     einfo "Running $DEBOOTSTRAP $DEBOOTSTRAP_OPT for release ${RELEASE}${ARCHINFO} using ${MIRROR}"
1743     einfo "Executing: $DEBOOTSTRAP $ARCHCMD $DEBOOTSTRAP_OPT $RELEASE $MNTPOINT $MIRROR"
1744     # shellcheck disable=SC2086
1745     "$DEBOOTSTRAP" $ARCHCMD $DEBOOTSTRAP_OPT "$RELEASE" "$MNTPOINT" "$MIRROR"
1746     RC=$?
1747   fi
1748
1749   if [ $RC -ne 0 ] ; then
1750     if [ -r "$MNTPOINT/debootstrap/debootstrap.log" ] && \
1751       [ -s "$MNTPOINT/debootstrap/debootstrap.log" ] ; then
1752       einfo "Presenting last ten lines of debootstrap.log:"
1753       tail -10 "${MNTPOINT}"/debootstrap/debootstrap.log
1754       einfo "End of debootstrap.log"
1755     fi
1756   fi
1757
1758   eend $RC
1759 }
1760 # }}}
1761
1762 # prepare chroot via chroot-script {{{
1763 preparechroot() {
1764   einfo "Preparing chroot system"
1765
1766   # provide variables to chroot system
1767   CHROOT_VARIABLES="/var/cache/grml-debootstrap/variables_${SHORT_TARGET}"
1768   touch "$CHROOT_VARIABLES"
1769   chmod 600 "$CHROOT_VARIABLES" # make sure nobody except root can read it
1770   echo "# Configuration of ${PN}"                                                                                   > "$CHROOT_VARIABLES"
1771   [ -n "$ARCH" ]                      && echo "ARCH='${ARCH//\'/\'\\\'\'}'"                                         >> "$CHROOT_VARIABLES"
1772   [ -n "$BACKPORTREPOS" ]             && echo "BACKPORTREPOS='${BACKPORTREPOS//\'/\'\\\'\'}'"                       >> "$CHROOT_VARIABLES"
1773   [ -n "$BOOT_APPEND" ]               && echo "BOOT_APPEND='${BOOT_APPEND//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1774   [ -n "$CHROOT_SCRIPTS" ]            && echo "CHROOT_SCRIPTS='${CHROOT_SCRIPTS//\'/\'\\\'\'}'"                     >> "$CHROOT_VARIABLES"
1775   [ -n "$COMPONENTS" ]                && echo "COMPONENTS='${COMPONENTS//\'/\'\\\'\'}'"                             >> "$CHROOT_VARIABLES"
1776   [ -n "$CONFFILES" ]                 && echo "CONFFILES='${CONFFILES//\'/\'\\\'\'}'"                               >> "$CHROOT_VARIABLES"
1777   [ -n "$DEBCONF" ]                   && echo "DEBCONF='${DEBCONF//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1778   [ -n "$DEBIAN_FRONTEND" ]           && echo "DEBIAN_FRONTEND='${DEBIAN_FRONTEND//\'/\'\\\'\'}'"                   >> "$CHROOT_VARIABLES"
1779   [ -n "$DEBOOTSTRAP" ]               && echo "DEBOOTSTRAP='${DEBOOTSTRAP//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1780   [ -n "$DEFAULT_LOCALES" ]           && echo "DEFAULT_LOCALES='${DEFAULT_LOCALES//\'/\'\\\'\'}'"                   >> "$CHROOT_VARIABLES"
1781   [ -n "$DEFAULT_LANGUAGE" ]          && echo "DEFAULT_LANGUAGE='${DEFAULT_LANGUAGE//\'/\'\\\'\'}'"                 >> "$CHROOT_VARIABLES"
1782   [ -n "$EXTRAPACKAGES" ]             && echo "EXTRAPACKAGES='${EXTRAPACKAGES//\'/\'\\\'\'}'"                       >> "$CHROOT_VARIABLES"
1783   [ -n "$EFI" ]                       && echo "EFI='${EFI//\'/\'\\\'\'}'"                                           >> "$CHROOT_VARIABLES"
1784   [ -n "$FALLBACK_MIRROR" ]           && echo "FALLBACK_MIRROR='${FALLBACK_MIRROR//\'/\'\\\'\'}'"                   >> "$CHROOT_VARIABLES"
1785   [ -n "$FILESYSTEM" ]                && echo "FILESYSTEM='${FILESYSTEM//\'/\'\\\'\'}'"                             >> "$CHROOT_VARIABLES"
1786   [ -n "$FORCE" ]                     && echo "FORCE='${FORCE//\'/\'\\\'\'}'"                                       >> "$CHROOT_VARIABLES"
1787   [ -n "$GRMLREPOS" ]                 && echo "GRMLREPOS='${GRMLREPOS//\'/\'\\\'\'}'"                               >> "$CHROOT_VARIABLES"
1788   [ -n "$GRUB" ]                      && echo "GRUB='${GRUB//\'/\'\\\'\'}'"                                         >> "$CHROOT_VARIABLES"
1789   [ -n "$HOSTNAME" ]                  && echo "HOSTNAME='${HOSTNAME//\'/\'\\\'\'}'"                                 >> "$CHROOT_VARIABLES"
1790   [ -n "$INITRD" ]                    && echo "INITRD='${INITRD//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1791   [ -n "$INITRD_GENERATOR" ]          && echo "INITRD_GENERATOR='${INITRD_GENERATOR//\'/\'\\\'\'}'"                 >> "$CHROOT_VARIABLES"
1792   [ -n "$INITRD_GENERATOR_OPTS" ]     && echo "INITRD_GENERATOR_OPTS='${INITRD_GENERATOR_OPTS//\'/\'\\\'\'}'"       >> "$CHROOT_VARIABLES"
1793   [ -n "$INSTALL_NOTES" ]             && echo "INSTALL_NOTES='${INSTALL_NOTES//\'/\'\\\'\'}'"                       >> "$CHROOT_VARIABLES"
1794   [ -n "$ISODIR" ]                    && echo "ISODIR='${ISO//\'/\'\\\'\'}'"                                        >> "$CHROOT_VARIABLES"
1795   [ -n "$ISO" ]                       && echo "ISO='${ISO//\'/\'\\\'\'}'"                                           >> "$CHROOT_VARIABLES"
1796   [ -n "$KEEP_SRC_LIST" ]             && echo "KEEP_SRC_LIST='${KEEP_SRC_LIST//\'/\'\\\'\'}'"                       >> "$CHROOT_VARIABLES"
1797   [ -n "$LOCALES" ]                   && echo "LOCALES='${LOCALES//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1798   [ -n "$MIRROR" ]                    && echo "MIRROR='${MIRROR//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1799   [ -n "$MKFS" ]                      && echo "MKFS='${MKFS//\'/\'\\\'\'}'"                                         >> "$CHROOT_VARIABLES"
1800   [ -n "$NOPASSWORD" ]                && echo "NOPASSWORD=\"true\""                                                 >> "$CHROOT_VARIABLES"
1801   [ -n "$NOKERNEL" ]                  && echo "NOKERNEL=\"true\""                                                   >> "$CHROOT_VARIABLES"
1802   [ -n "$PACKAGES" ]                  && echo "PACKAGES='${PACKAGES//\'/\'\\\'\'}'"                                 >> "$CHROOT_VARIABLES"
1803   [ -n "$POST_SCRIPTS" ]              && echo "POST_SCRIPTS='${POST_SCRIPTS//\'/\'\\\'\'}'"                         >> "$CHROOT_VARIABLES"
1804   [ -n "$PRE_SCRIPTS" ]               && echo "PRE_SCRIPTS='${PRE_SCRIPTS//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1805   [ -n "$RECONFIGURE" ]               && echo "RECONFIGURE='${RECONFIGURE//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1806   [ -n "$RELEASE" ]                   && echo "RELEASE='${RELEASE//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1807   [ -n "$RM_APTCACHE" ]               && echo "RM_APTCACHE='${RM_APTCACHE//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1808   [ -n "$ROOTPASSWORD" ]              && echo "ROOTPASSWORD='${ROOTPASSWORD//\'/\'\\\'\'}'"                         >> "$CHROOT_VARIABLES"
1809   [ -n "$SCRIPTS" ]                   && echo "SCRIPTS='${SCRIPTS//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1810   [ -n "$SECURE" ]                    && echo "SECURE='${SECURE//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1811   [ -n "$SELECTED_PARTITIONS" ]       && echo "SELECTED_PARTITIONS='${SELECTED_PARTITIONS//\'/\'\\\'\'}'"           >> "$CHROOT_VARIABLES"
1812   [ -n "$TARGET" ]                    && echo "TARGET='${TARGET//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1813   [ -n "$UPGRADE_SYSTEM" ]            && echo "UPGRADE_SYSTEM='${UPGRADE_SYSTEM//\'/\'\\\'\'}'"                     >> "$CHROOT_VARIABLES"
1814   [ -n "$TARGET_UUID" ]               && echo "TARGET_UUID='${TARGET_UUID//\'/\'\\\'\'}'"                           >> "$CHROOT_VARIABLES"
1815   [ -n "$TIMEZONE" ]                  && echo "TIMEZONE='${TIMEZONE//\'/\'\\\'\'}'"                                 >> "$CHROOT_VARIABLES"
1816   [ -n "$TUNE2FS" ]                   && echo "TUNE2FS='${TUNE2FS//\'/\'\\\'\'}'"                                   >> "$CHROOT_VARIABLES"
1817   [ -n "$VMSIZE" ]                    && echo "VMSIZE='${VMSIZE//\'/\'\\\'\'}'"                                     >> "$CHROOT_VARIABLES"
1818
1819   cp $VERBOSE "${CONFFILES}"/chroot-script "${MNTPOINT}"/bin/chroot-script
1820   chmod 755 "${MNTPOINT}"/bin/chroot-script
1821   [ -d "$MNTPOINT"/etc/debootstrap/ ] || mkdir "$MNTPOINT"/etc/debootstrap/
1822
1823   # make sure we have our files for later use via chroot-script
1824   cp $VERBOSE "${CONFFILES}/config"           "${MNTPOINT}"/etc/debootstrap/
1825   # make sure we adjust the configuration variables accordingly:
1826   sed -i "s#RELEASE=.*#RELEASE=\"$RELEASE\"#" "${MNTPOINT}"/etc/debootstrap/config
1827   sed -i "s#TARGET=.*#TARGET=\"$TARGET\"#"    "${MNTPOINT}"/etc/debootstrap/config
1828   sed -i "s#GRUB=.*#GRUB=\"$GRUB\"#"          "${MNTPOINT}"/etc/debootstrap/config
1829
1830   # install notes:
1831   if [ -n "$INSTALL_NOTES" ] ; then
1832      [ -r "$INSTALL_NOTES" ] && cp "$INSTALL_NOTES" "${MNTPOINT}"/etc/debootstrap/
1833   fi
1834
1835   # package selection:
1836   if [ "$PACKAGES" = 'yes' ] ; then
1837     PACKAGES_FILE="packages"
1838
1839     if [ "$ARCH" = 'arm64' ]; then
1840       PACKAGES_FILE="packages-arm64"
1841     fi
1842
1843     cp $VERBOSE "${_opt_packages:-$CONFFILES/$PACKAGES_FILE}" \
1844       "${MNTPOINT}/etc/debootstrap/${PACKAGES_FILE}"
1845   fi
1846
1847   # debconf preseeding:
1848   _opt_debconf=${_opt_debconf:-$CONFFILES/debconf-selections}
1849   [ -f "${_opt_debconf}" ] && [ "$DEBCONF" = 'yes' ] && \
1850     cp $VERBOSE "${_opt_debconf}" "${MNTPOINT}"/etc/debootstrap/debconf-selections
1851
1852   # copy scripts that should be executed inside the chroot:
1853   _opt_chroot_scripts=${_opt_chroot_scripts:-$CONFFILES/chroot-scripts/}
1854   [ -d "$_opt_chroot_scripts" ] && [ "$CHROOT_SCRIPTS" = 'yes' ] && {
1855     mkdir -p "${MNTPOINT}"/etc/debootstrap/chroot-scripts
1856     cp -a $VERBOSE "${_opt_chroot_scripts}"/* "${MNTPOINT}"/etc/debootstrap/chroot-scripts/
1857   }
1858
1859   # notice: do NOT use $CHROOT_VARIABLES inside chroot but statically file instead!
1860   cp $VERBOSE "${CHROOT_VARIABLES}" "${MNTPOINT}"/etc/debootstrap/variables
1861
1862   cp $VERBOSE -a -L "${CONFFILES}"/extrapackages/ "${MNTPOINT}"/etc/debootstrap/
1863
1864   # make sure we can access network [relevant for cdebootstrap/mmdebstrap]
1865   [ -f "${MNTPOINT}"/etc/resolv.conf ] || cp $VERBOSE /etc/resolv.conf "${MNTPOINT}"/etc/resolv.conf
1866
1867   # setup default locales
1868   [ -n "$LOCALES" ] && cp $VERBOSE "${CONFFILES}"/locale.gen "${MNTPOINT}"/etc/locale.gen
1869
1870   # copy any existing files to chroot
1871   [ -d "${CONFFILES}"/bin   ] && cp $VERBOSE -a -L "${CONFFILES}"/bin/*   "${MNTPOINT}"/bin/
1872   [ -d "${CONFFILES}"/boot  ] && cp $VERBOSE -a -L "${CONFFILES}"/boot/*  "${MNTPOINT}"/boot/
1873   [ -d "${CONFFILES}"/etc   ] && cp $VERBOSE -a -L "${CONFFILES}"/etc/*   "${MNTPOINT}"/etc/
1874   [ -d "${CONFFILES}"/sbin  ] && cp $VERBOSE -a -L "${CONFFILES}"/sbin/*  "${MNTPOINT}"/sbin/
1875   [ -d "${CONFFILES}"/share ] && cp $VERBOSE -a -L "${CONFFILES}"/share/* "${MNTPOINT}"/share/
1876   [ -d "${CONFFILES}"/usr   ] && cp $VERBOSE -a -L "${CONFFILES}"/usr/*   "${MNTPOINT}"/usr/
1877   [ -d "${CONFFILES}"/var   ] && cp $VERBOSE -a -L "${CONFFILES}"/var/*   "${MNTPOINT}"/var/
1878
1879   # network setup
1880   DEFAULT_INTERFACES="# /etc/network/interfaces - generated by grml-debootstrap
1881
1882 # Include files from /etc/network/interfaces.d when using
1883 # ifupdown v0.7.44 or newer:
1884 #source-directory /etc/network/interfaces.d
1885
1886 auto lo
1887 iface lo inet loopback
1888
1889 allow-hotplug eth0
1890 iface eth0 inet dhcp
1891 "
1892
1893   # add dhcp setting for Predictable Network Interface Names
1894   if [ -x /bin/udevadm ]; then
1895     tmpfile=$(mktemp)
1896     for interface in /sys/class/net/*; do
1897       udevadm info --query=all --path="${interface}" > "${tmpfile}"
1898       # skip virtual devices, like bridges, vboxnet,...
1899       if grep -q 'P: /devices/virtual/net/' "${tmpfile}" ; then
1900         continue
1901       fi
1902
1903       # iterate over possible naming policies by precedence (see udev/net/link-config.c),
1904       # use and stop on first match to have same behavior as udev's link_config_apply()
1905       for property in ID_NET_NAME_FROM_DATABASE ID_NET_NAME_ONBOARD ID_NET_NAME_SLOT ID_NET_NAME_PATH ID_NET_NAME_MAC ; do
1906         if grep -q "${property}" "${tmpfile}" ; then
1907           interface=$(grep "${property}" "${tmpfile}" | sed -n -e "s/E: ${property}=\([^\$*]\)/\1/p")
1908           DEFAULT_INTERFACES="${DEFAULT_INTERFACES}
1909 allow-hotplug ${interface}
1910 iface ${interface} inet dhcp
1911 "
1912           break
1913         fi
1914       done
1915     done
1916     rm -f "${tmpfile}"
1917   fi
1918
1919   if [ -n "$NOINTERFACES" ] ; then
1920     einfo "Not installing /etc/network/interfaces as requested via --nointerfaces option"
1921   elif [ -n "$USE_DEFAULT_INTERFACES" ] ; then
1922     einfo "Installing default /etc/network/interfaces as requested via --defaultinterfaces options."
1923     mkdir -p "${MNTPOINT}/etc/network"
1924     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1925   elif [ -n "$VIRTUAL" ] ; then
1926     einfo "Setting up Virtual Machine, installing default /etc/network/interfaces"
1927     mkdir -p "${MNTPOINT}/etc/network"
1928     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1929   elif [ -r /etc/network/interfaces ] ; then
1930     einfo "Copying /etc/network/interfaces from host to target system"
1931     mkdir -p "${MNTPOINT}/etc/network"
1932     cp $VERBOSE /etc/network/interfaces "${MNTPOINT}/etc/network/interfaces"
1933   else
1934     ewarn "Couldn't read /etc/network/interfaces, installing default /etc/network/interfaces"
1935     mkdir -p "${MNTPOINT}/etc/network"
1936     echo "$DEFAULT_INTERFACES" > "${MNTPOINT}/etc/network/interfaces"
1937   fi
1938
1939   # install config file providing some example entries
1940   if [ -r /etc/network/interfaces.examples ] && [ ! -r "$MNTPOINT/etc/network/interfaces.examples" ] ; then
1941     mkdir -p "${MNTPOINT}/etc/network"
1942     cp /etc/network/interfaces.examples "$MNTPOINT/etc/network/interfaces.examples"
1943   fi
1944
1945   if [ -n "${SSHCOPYID}" ] ; then
1946     AUTHORIZED_KEYS_SOURCE=${AUTHORIZED_KEYS_SOURCE:-$HOME/.ssh/authorized_keys}
1947     AUTHORIZED_KEYS_TARGET=${AUTHORIZED_KEYS_TARGET:-$MNTPOINT/root/.ssh/}
1948     if ssh-add -L >/dev/null 2>&1 ; then
1949       einfo "Use locally available public keys to authorise root login on the target system as requested via --sshcopyid option."
1950       mkdir -p "${MNTPOINT}"/root/.ssh
1951       chmod 0700 "${MNTPOINT}"/root/.ssh
1952       if ! ssh-add -L >> "${MNTPOINT}"/root/.ssh/authorized_keys ; then
1953         eerror "Error: executing 'ssh-add -L' failed."
1954         bailout 1
1955       fi
1956     elif [ -f "$AUTHORIZED_KEYS_SOURCE" ]; then
1957       einfo "copying '$AUTHORIZED_KEYS_SOURCE' to '$AUTHORIZED_KEYS_TARGET' as requested via --sshcopyid option."
1958       mkdir -p "$AUTHORIZED_KEYS_TARGET"
1959       chmod 0700 "$AUTHORIZED_KEYS_TARGET"
1960       if ! cp "$AUTHORIZED_KEYS_SOURCE" "$AUTHORIZED_KEYS_TARGET" ; then
1961         eerror "Error: copying '$AUTHORIZED_KEYS_SOURCE' to '$AUTHORIZED_KEYS_TARGET' failed"
1962         bailout 1
1963       fi
1964     else
1965       eerror "Error: Could not open a connection to your authentication agent or the agent has no identities."
1966       bailout 1
1967     fi
1968   fi
1969
1970   if [ -n "${SSHCOPYAUTH}" ] ; then
1971     AUTHORIZED_KEYS_SOURCE=${AUTHORIZED_KEYS_SOURCE:-${HOME}/.ssh/authorized_keys}
1972
1973     if ! [ -f "${AUTHORIZED_KEYS_SOURCE}" ]; then
1974       eerror "Error: could not read '${AUTHORIZED_KEYS_SOURCE}' for setting up SSH key login."
1975       bailout 1
1976     fi
1977
1978     AUTHORIZED_KEYS_TARGET="${MNTPOINT}/root/.ssh/"
1979     einfo "Copying '${AUTHORIZED_KEYS_SOURCE}' to '${AUTHORIZED_KEYS_TARGET}' as requested via --sshcopyauth option."
1980     mkdir -p "${AUTHORIZED_KEYS_TARGET}"
1981     chmod 0700 "${AUTHORIZED_KEYS_TARGET}"
1982     if ! cp "${AUTHORIZED_KEYS_SOURCE}" "${AUTHORIZED_KEYS_TARGET}" ; then
1983       eerror "Error: copying '${AUTHORIZED_KEYS_SOURCE}' to '${AUTHORIZED_KEYS_TARGET}' failed."
1984       bailout 1
1985     fi
1986   fi
1987
1988   if [ -d /run/udev ] ; then
1989     einfo "Setting up bind-mount /run/udev"
1990     mkdir -p "${MNTPOINT}"/run/udev
1991     mount --bind /run/udev "${MNTPOINT}"/run/udev
1992   fi
1993 }
1994 # }}}
1995
1996 # execute all scripts in /etc/debootstrap/pre-scripts/ {{{
1997 execute_pre_scripts() {
1998   # make sure hostname is set even before chroot-script get executed
1999   echo "$HOSTNAME" > "$MNTPOINT"/etc/hostname
2000
2001   # make sure we have $MNTPOINT available for our scripts
2002   export MNTPOINT
2003
2004   if [ -d "$_opt_pre_scripts" ] || [ "$PRE_SCRIPTS" = 'yes' ] ; then
2005     [ -d "$_opt_pre_scripts" ] && pre_scripts="$_opt_pre_scripts" || pre_scripts="${CONFFILES}/pre-scripts/"
2006     for script in "${pre_scripts}"/* ; do
2007       if [ -x "$script" ] ; then
2008         einfo "Executing pre-script $script"
2009         "$script"
2010       fi
2011     done
2012   fi
2013 }
2014 # }}}
2015
2016 # execute all scripts in /etc/debootstrap/post-scripts/ {{{
2017 execute_post_scripts() {
2018   # make sure we have $MNTPOINT and HOSTNAME available for our scripts
2019   export MNTPOINT
2020   export TARGET_HOSTNAME=$HOSTNAME
2021
2022   if [ -d "$_opt_scripts" ] || [ "$SCRIPTS" = 'yes' ] ; then
2023     # legacy support for /etc/debootstrap/scripts/
2024     [ -d "$_opt_scripts" ] && post_scripts="$_opt_scripts" || post_scripts="${CONFFILES}/scripts/"
2025     ewarn "Deprecation NOTE: --scripts/SCRIPTS are deprecated, please switch to --post-scripts/POST_SCRIPTS instead."
2026   elif [ -d "$_opt_post_scripts" ] || [ "$POST_SCRIPTS" = 'yes' ] ; then
2027     [ -d "$_opt_post_scripts" ] && post_scripts="$_opt_post_scripts" || post_scripts="${CONFFILES}/post-scripts/"
2028   fi
2029
2030   if [ -n "$post_scripts" ] ; then
2031     for script in "${post_scripts}"/* ; do
2032       if [ -x "$script" ] ; then
2033         einfo "Executing post-script $script"
2034         "$script"
2035       fi
2036     done
2037   fi
2038 }
2039 # }}}
2040
2041 # unmount mountpoint {{{
2042 try_umount() {
2043   local tries=$1
2044   local mountpoint="$2"
2045
2046   for (( try=1; try<=tries; try++ )); do
2047     if [[ ${try} -eq ${tries} ]]; then
2048       # Last time, show errors this time
2049       umount "${mountpoint}" && return 0
2050     else
2051       # Not last time, hide errors until fatal
2052       if umount "${mountpoint}" 2>/dev/null ; then
2053         return 0
2054       else
2055         sleep 1
2056       fi
2057     fi
2058   done
2059   return 1  # Tried enough
2060 }
2061 # }}}
2062
2063 # execute chroot-script {{{
2064 chrootscript() {
2065   if ! [ -r "$MNTPOINT/bin/chroot-script" ] ; then
2066     mount_target
2067   fi
2068
2069   if ! [ -x "$MNTPOINT/bin/chroot-script" ] ; then
2070     eerror "Fatal: $MNTPOINT/bin/chroot-script could not be found."
2071     eend 1
2072   else
2073     einfo "Executing chroot-script now"
2074     mount -t devtmpfs udev "${MNTPOINT}"/dev
2075     mount -t devpts devpts "${MNTPOINT}"/dev/pts
2076     if [ "$DEBUG" = "true" ] ; then
2077       chroot "$MNTPOINT" /bin/bash -x /bin/chroot-script ; RC=$?
2078     else
2079       chroot "$MNTPOINT" /bin/chroot-script ; RC=$?
2080     fi
2081     try_umount 3 "$MNTPOINT"/dev/pts
2082     try_umount 3 "$MNTPOINT"/dev
2083     eend $RC
2084   fi
2085
2086   # finally get rid of chroot-script again, there's no good reason to
2087   # keep it on the installed system
2088   if grep -q GRML_CHROOT_SCRIPT_MARKER "${MNTPOINT}/bin/chroot-script" ; then
2089     einfo "Removing chroot-script again"
2090     rm -f "${MNTPOINT}/bin/chroot-script"
2091   else
2092     einfo "Keeping chroot-script as string GRML_CHROOT_SCRIPT_MARKER could not be found"
2093   fi
2094 }
2095 # }}}
2096
2097 # unmount $MNTPOINT {{{
2098 umount_chroot() {
2099
2100   # display installation notes:
2101   if [ -n "$INSTALL_NOTES" ] ; then
2102      [ -r "${MNTPOINT}/${INSTALL_NOTES}" ] && cat "${MNTPOINT}/${INSTALL_NOTES}"
2103   fi
2104
2105   if [ -n "$ISODIR" ] ; then
2106      if grep -q "$ISODIR" /proc/mounts ; then
2107         einfo "Unmount $MNTPOINT/$ISODIR"
2108         umount "$MNTPOINT/$ISODIR"
2109      fi
2110   fi
2111
2112   if grep -q "$MNTPOINT" /proc/mounts ; then
2113     if mountpoint "${MNTPOINT}"/run/udev &>/dev/null ; then
2114       einfo "Unmounting bind-mount /run/udev"
2115       umount "${MNTPOINT}"/run/udev
2116     fi
2117
2118      if [ -n "$PARTITION" ] ; then
2119         einfo "Unmount $MNTPOINT"
2120         umount "$MNTPOINT"
2121      fi
2122   fi
2123 }
2124 # }}}
2125
2126 # execute filesystem check {{{
2127 fscktool() {
2128  if [ -n "$VIRTUAL" ] ; then
2129    einfo "Skipping filesystem check because we deploy a virtual machine."
2130    return 0
2131  fi
2132
2133  if [ "$FSCK" = 'yes' ] ; then
2134    [ -n "$FSCKTOOL" ] || FSCKTOOL="fsck.${MKFS#mkfs.}"
2135    einfo "Checking filesystem on $TARGET using $FSCKTOOL"
2136    "$FSCKTOOL" "$TARGET"
2137  fi
2138 }
2139 # }}}
2140
2141 # get rid of grml-debootstrap config files {{{
2142 remove_configs() {
2143   if [ "$REMOVE_CONFIGS" != "yes" ] ; then
2144     return 0
2145   fi
2146
2147   if ! mountpoint "${MNTPOINT}" >/dev/null 2>&1 ; then
2148     ewarn "Target ${MNTPOINT} doesn't seem to be mounted, can't remove configuration files."
2149     return 0
2150   fi
2151
2152   einfo "Removing configuration files from installed system as requested via --remove-configs / REMOVE_CONFIGS."
2153   rm -rf "${MNTPOINT}"/etc/debootstrap/
2154 }
2155 # }}}
2156
2157 # now execute all the functions {{{
2158 for i in format_efi_partition prepare_vm mkfs tunefs \
2159          mount_target mountpoint_to_blockdevice debootstrap_system \
2160          preparechroot execute_pre_scripts chrootscript execute_post_scripts \
2161          remove_configs umount_chroot grub_install umount_target fscktool ; do
2162     if stage "${i}" ; then
2163       "$i"
2164       if [ $? -eq 0 ]; then
2165         stage "${i}" 'done' && rm -f "${STAGES}/${i}"
2166       else
2167         bailout 2 "$i"
2168       fi
2169     fi
2170 done
2171
2172 cleanup
2173 # }}}
2174
2175 # end dialog of autoinstallation {{{
2176 if [ -n "$AUTOINSTALL" ] ; then
2177    if dialog --title "${PN}" --pause "Finished execution of ${PN}.
2178 Automatically rebooting in 10 seconds.
2179
2180 Choose Cancel to skip rebooting." 10 60 10 ; then
2181      noeject noprompt reboot
2182   fi
2183 else
2184    einfo "Finished execution of ${PN}. Enjoy your Debian system."
2185 fi
2186 # }}}
2187
2188 ## END OF FILE #################################################################
2189 # vim: ai tw=100 expandtab foldmethod=marker shiftwidth=2